module gleeFuncDef;

/////////////////////////////////////////////////////////////////////
//
// GLeeFuncDef.d
// OpenGL Easy Extension library
// Version : 3.02
//
// Copyright (c);2004  Ben Woodhouse  All rights reserved.
//
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions are
// met:
// 1. Redistributions of source code must retain the above copyright
// notice, this list of conditions and the following disclaimer as
// the first lines of this file unmodified.
// 2. Redistributions in binary form must reproduce the above copyright
// notice, this list of conditions and the following disclaimer in the
// documentation and/or other materials provided with the distribution.
//
// THIS SOFTWARE IS PROVIDED BY BEN WOODHOUSE ``AS IS'' AND ANY EXPRESS OR
// IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
// OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
// IN NO EVENT SHALL BEN WOODHOUSE BE LIABLE FOR ANY DIRECT, INDIRECT,
// INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
// NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
// DATA, OR PROFITS; OR BUSINESS INTERRUPTION); HOWEVER CAUSED AND ON ANY
// THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
// (INCLUDING NEGLIGENCE OR OTHERWISE); ARISING IN ANY WAY OUT OF THE USE OF
// THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//
// This licence includes and incorporates the SGI FREE SOFTWARE LICENSE B
// (Version 1.1 [02/22/2000]); full details of which can be found at
// http://oss.sgi.com/projects/FreeB
//
// For the avoidance of doubt, this work falls within the definition of a
// 'Larger Work' within that licence, since it incorporates parts of SGI's
// glExt.h, wglExt.h and glxExt.h header files, which form part of SGI's
// OpenGL Sample Implementation.
// Web: http://elf-stone.com
//
// [This file was produced using find and replace and by hand by
// Joel Anderson]
//
///////////////////////////////////////////////////////////////////// void glBlendColor(GLclampf red, GLclampf green, GLclampf blue, GLclampf alpha);

private
{
    version (Win32) {
        import std.c.windows.windows;
    }
    //import glConstants;
    import gleeTypes;
	import opengl;
}

extern (C)
{


	//GL_VERSION_1_2
	version(GL_VERSION_1_2)
	{
		 void glBlendColor(GLclampf red, GLclampf green, GLclampf blue, GLclampf alpha);
		 void glBlendEquation(GLenum mode);
		 void glDrawRangeElements(GLenum mode, GLuint start, GLuint end, GLsizei count, GLenum type, GLvoid *indices);
		 void glColorTable(GLenum target, GLenum internalformat, GLsizei width, GLenum format, GLenum type, GLvoid *table);
		 void glColorTableParameterfv(GLenum target, GLenum pname, GLfloat *params);
		 void glColorTableParameteriv(GLenum target, GLenum pname, GLint *params);
		 void glCopyColorTable(GLenum target, GLenum internalformat, GLint x, GLint y, GLsizei width);
		 void glGetColorTable(GLenum target, GLenum format, GLenum type, GLvoid *table);
		 void glGetColorTableParameterfv(GLenum target, GLenum pname, GLfloat *params);
		 void glGetColorTableParameteriv(GLenum target, GLenum pname, GLint *params);
		 void glColorSubTable(GLenum target, GLsizei start, GLsizei count, GLenum format, GLenum type, GLvoid *data);
		 void glCopyColorSubTable(GLenum target, GLsizei start, GLint x, GLint y, GLsizei width);
		 void glConvolutionFilter1D(GLenum target, GLenum internalformat, GLsizei width, GLenum format, GLenum type, GLvoid *image);
		 void glConvolutionFilter2D(GLenum target, GLenum internalformat, GLsizei width, GLsizei height, GLenum format, GLenum type, GLvoid *image);
		 void glConvolutionParameterf(GLenum target, GLenum pname, GLfloat params);
		 void glConvolutionParameterfv(GLenum target, GLenum pname, GLfloat *params);
		 void glConvolutionParameteri(GLenum target, GLenum pname, GLint params);
		 void glConvolutionParameteriv(GLenum target, GLenum pname, GLint *params);
		 void glCopyConvolutionFilter1D(GLenum target, GLenum internalformat, GLint x, GLint y, GLsizei width);
		 void glCopyConvolutionFilter2D(GLenum target, GLenum internalformat, GLint x, GLint y, GLsizei width, GLsizei height);
		 void glGetConvolutionFilter(GLenum target, GLenum format, GLenum type, GLvoid *image);
		 void glGetConvolutionParameterfv(GLenum target, GLenum pname, GLfloat *params);
		 void glGetConvolutionParameteriv(GLenum target, GLenum pname, GLint *params);
		 void glGetSeparableFilter(GLenum target, GLenum format, GLenum type, GLvoid *row, GLvoid *column, GLvoid *span);
		 void glSeparableFilter2D(GLenum target, GLenum internalformat, GLsizei width, GLsizei height, GLenum format, GLenum type, GLvoid *row, GLvoid *column);
		 void glGetHistogram(GLenum target, GLboolean reset, GLenum format, GLenum type, GLvoid *values);
		 void glGetHistogramParameterfv(GLenum target, GLenum pname, GLfloat *params);
		 void glGetHistogramParameteriv(GLenum target, GLenum pname, GLint *params);
		 void glGetMinmax(GLenum target, GLboolean reset, GLenum format, GLenum type, GLvoid *values);
		 void glGetMinmaxParameterfv(GLenum target, GLenum pname, GLfloat *params);
		 void glGetMinmaxParameteriv(GLenum target, GLenum pname, GLint *params);
		 void glHistogram(GLenum target, GLsizei width, GLenum internalformat, GLboolean sink);
		 void glMinmax(GLenum target, GLenum internalformat, GLboolean sink);
		 void glResetHistogram(GLenum target);
		 void glResetMinmax(GLenum target);
		 void glTexImage3D(GLenum target, GLint level, GLint internalformat, GLsizei width, GLsizei height, GLsizei depth, GLint border, GLenum format, GLenum type, GLvoid *pixels);
		 void glTexSubImage3D(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLsizei width, GLsizei height, GLsizei depth, GLenum format, GLenum type, GLvoid *pixels);
		 void glCopyTexSubImage3D(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLint x, GLint y, GLsizei width, GLsizei height);
	}

	//GL_ARB_imaging
	version(GL_ARB_imaging)
{}

	//GL_VERSION_1_3
	version(GL_VERSION_1_3)
	{
		 void glActiveTexture(GLenum texture);
		 void glClientActiveTexture(GLenum texture);
		 void glMultiTexCoord1d(GLenum target, GLdouble s);
		 void glMultiTexCoord1dv(GLenum target, GLdouble *v);
		 void glMultiTexCoord1f(GLenum target, GLfloat s);
		 void glMultiTexCoord1fv(GLenum target, GLfloat *v);
		 void glMultiTexCoord1i(GLenum target, GLint s);
		 void glMultiTexCoord1iv(GLenum target, GLint *v);
		 void glMultiTexCoord1s(GLenum target, GLshort s);
		 void glMultiTexCoord1sv(GLenum target, GLshort *v);
		 void glMultiTexCoord2d(GLenum target, GLdouble s, GLdouble t);
		 void glMultiTexCoord2dv(GLenum target, GLdouble *v);
		 void glMultiTexCoord2f(GLenum target, GLfloat s, GLfloat t);
		 void glMultiTexCoord2fv(GLenum target, GLfloat *v);
		 void glMultiTexCoord2i(GLenum target, GLint s, GLint t);
		 void glMultiTexCoord2iv(GLenum target, GLint *v);
		 void glMultiTexCoord2s(GLenum target, GLshort s, GLshort t);
		 void glMultiTexCoord2sv(GLenum target, GLshort *v);
		 void glMultiTexCoord3d(GLenum target, GLdouble s, GLdouble t, GLdouble r);
		 void glMultiTexCoord3dv(GLenum target, GLdouble *v);
		 void glMultiTexCoord3f(GLenum target, GLfloat s, GLfloat t, GLfloat r);
		 void glMultiTexCoord3fv(GLenum target, GLfloat *v);
		 void glMultiTexCoord3i(GLenum target, GLint s, GLint t, GLint r);
		 void glMultiTexCoord3iv(GLenum target, GLint *v);
		 void glMultiTexCoord3s(GLenum target, GLshort s, GLshort t, GLshort r);
		 void glMultiTexCoord3sv(GLenum target, GLshort *v);
		 void glMultiTexCoord4d(GLenum target, GLdouble s, GLdouble t, GLdouble r, GLdouble q);
		 void glMultiTexCoord4dv(GLenum target, GLdouble *v);
		 void glMultiTexCoord4f(GLenum target, GLfloat s, GLfloat t, GLfloat r, GLfloat q);
		 void glMultiTexCoord4fv(GLenum target, GLfloat *v);
		 void glMultiTexCoord4i(GLenum target, GLint s, GLint t, GLint r, GLint q);
		 void glMultiTexCoord4iv(GLenum target, GLint *v);
		 void glMultiTexCoord4s(GLenum target, GLshort s, GLshort t, GLshort r, GLshort q);
		 void glMultiTexCoord4sv(GLenum target, GLshort *v);
		 void glLoadTransposeMatrixf(GLfloat *m);
		 void glLoadTransposeMatrixd(GLdouble *m);
		 void glMultTransposeMatrixf(GLfloat *m);
		 void glMultTransposeMatrixd(GLdouble *m);
		 void glSampleCoverage(GLclampf value, GLboolean invert);
		 void glCompressedTexImage3D(GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLsizei depth, GLint border, GLsizei imageSize, GLvoid *data);
		 void glCompressedTexImage2D(GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLint border, GLsizei imageSize, GLvoid *data);
		 void glCompressedTexImage1D(GLenum target, GLint level, GLenum internalformat, GLsizei width, GLint border, GLsizei imageSize, GLvoid *data);
		 void glCompressedTexSubImage3D(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLsizei width, GLsizei height, GLsizei depth, GLenum format, GLsizei imageSize, GLvoid *data);
		 void glCompressedTexSubImage2D(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLsizei width, GLsizei height, GLenum format, GLsizei imageSize, GLvoid *data);
		 void glCompressedTexSubImage1D(GLenum target, GLint level, GLint xoffset, GLsizei width, GLenum format, GLsizei imageSize, GLvoid *data);
		 void glGetCompressedTexImage(GLenum target, GLint level, GLvoid *img);
	}

	//GL_VERSION_1_4
	version(GL_VERSION_1_4)
	{
		 void glBlendFuncSeparate(GLenum sfactorRGB, GLenum dfactorRGB, GLenum sfactorAlpha, GLenum dfactorAlpha);
		 void glFogCoordf(GLfloat coord);
		 void glFogCoordfv (GLfloat *coord);
		 void glFogCoordd(GLdouble coord);
		 void glFogCoorddv (GLdouble *coord);
		 void glFogCoordPointer(GLenum type, GLsizei stride, GLvoid *pointer);
		 void glMultiDrawArrays(GLenum mode, GLint *first, GLsizei *count, GLsizei primcount);
		 void glMultiDrawElements(GLenum mode, GLsizei *count, GLenum type, GLvoid* *indices, GLsizei primcount);
		 void glPointParameterf(GLenum pname, GLfloat param);
		 void glPointParameterfv(GLenum pname, GLfloat *params);
		 void glPointParameteri(GLenum pname, GLint param);
		 void glPointParameteriv(GLenum pname, GLint *params);
		 void glSecondaryColor3b(GLbyte red, GLbyte green, GLbyte blue);
		 void glSecondaryColor3bv (GLbyte *v);
		 void glSecondaryColor3d(GLdouble red, GLdouble green, GLdouble blue);
		 void glSecondaryColor3dv (GLdouble *v);
		 void glSecondaryColor3f(GLfloat red, GLfloat green, GLfloat blue);
		 void glSecondaryColor3fv (GLfloat *v);
		 void glSecondaryColor3i(GLint red, GLint green, GLint blue);
		 void glSecondaryColor3iv (GLint *v);
		 void glSecondaryColor3s(GLshort red, GLshort green, GLshort blue);
		 void glSecondaryColor3sv (GLshort *v);
		 void glSecondaryColor3ub(GLubyte red, GLubyte green, GLubyte blue);
		 void glSecondaryColor3ubv (GLubyte *v);
		 void glSecondaryColor3ui(GLuint red, GLuint green, GLuint blue);
		 void glSecondaryColor3uiv (GLuint *v);
		 void glSecondaryColor3us(GLushort red, GLushort green, GLushort blue);
		 void glSecondaryColor3usv (GLushort *v);
		 void glSecondaryColorPointer(GLint size, GLenum type, GLsizei stride, GLvoid *pointer);
		 void glWindowPos2d(GLdouble x, GLdouble y);
		 void glWindowPos2dv (GLdouble *v);
		 void glWindowPos2f(GLfloat x, GLfloat y);
		 void glWindowPos2fv (GLfloat *v);
		 void glWindowPos2i(GLint x, GLint y);
		 void glWindowPos2iv (GLint *v);
		 void glWindowPos2s(GLshort x, GLshort y);
		 void glWindowPos2sv (GLshort *v);
		 void glWindowPos3d(GLdouble x, GLdouble y, GLdouble z);
		 void glWindowPos3dv (GLdouble *v);
		 void glWindowPos3f(GLfloat x, GLfloat y, GLfloat z);
		 void glWindowPos3fv (GLfloat *v);
		 void glWindowPos3i(GLint x, GLint y, GLint z);
		 void glWindowPos3iv (GLint *v);
		 void glWindowPos3s(GLshort x, GLshort y, GLshort z);
		 void glWindowPos3sv (GLshort *v);
	}

	//GL_VERSION_1_5
	version(GL_VERSION_1_5)
	{
		 void glGenQueries(GLsizei n, GLuint *ids);
		 void glDeleteQueries(GLsizei n, GLuint *ids);
		 GLboolean glIsQuery(GLuint id);
		 void glBeginQuery(GLenum target, GLuint id);
		 void glEndQuery(GLenum target);
		 void glGetQueryiv(GLenum target, GLenum pname, GLint *params);
		 void glGetQueryObjectiv(GLuint id, GLenum pname, GLint *params);
		 void glGetQueryObjectuiv(GLuint id, GLenum pname, GLuint *params);
		 void glBindBuffer(GLenum target, GLuint buffer);
		 void glDeleteBuffers(GLsizei n, GLuint *buffers);
		 void glGenBuffers(GLsizei n, GLuint *buffers);
		 GLboolean glIsBuffer(GLuint buffer);
		 void glBufferData(GLenum target, GLsizeiptr size, GLvoid *data, GLenum usage);
		 void glBufferSubData(GLenum target, GLintptr offset, GLsizeiptr size, GLvoid *data);
		 void glGetBufferSubData(GLenum target, GLintptr offset, GLsizeiptr size, GLvoid *data);
		 GLvoid* glMapBuffer(GLenum target, GLenum access);
		 GLboolean glUnmapBuffer(GLenum target);
		 void glGetBufferParameteriv(GLenum target, GLenum pname, GLint *params);
		 void glGetBufferPointerv(GLenum target, GLenum pname, GLvoid* *params);
	}

	//GL_ARB_multitexture
	version(GL_ARB_multitexture)
	{
		 void glActiveTextureARB(GLenum texture);
		 void glClientActiveTextureARB(GLenum texture);
		 void glMultiTexCoord1dARB(GLenum target, GLdouble s);
		 void glMultiTexCoord1dvARB(GLenum target, GLdouble *v);
		 void glMultiTexCoord1fARB(GLenum target, GLfloat s);
		 void glMultiTexCoord1fvARB(GLenum target, GLfloat *v);
		 void glMultiTexCoord1iARB(GLenum target, GLint s);
		 void glMultiTexCoord1ivARB(GLenum target, GLint *v);
		 void glMultiTexCoord1sARB(GLenum target, GLshort s);
		 void glMultiTexCoord1svARB(GLenum target, GLshort *v);
		 void glMultiTexCoord2dARB(GLenum target, GLdouble s, GLdouble t);
		 void glMultiTexCoord2dvARB(GLenum target, GLdouble *v);
		 void glMultiTexCoord2fARB(GLenum target, GLfloat s, GLfloat t);
		 void glMultiTexCoord2fvARB(GLenum target, GLfloat *v);
		 void glMultiTexCoord2iARB(GLenum target, GLint s, GLint t);
		 void glMultiTexCoord2ivARB(GLenum target, GLint *v);
		 void glMultiTexCoord2sARB(GLenum target, GLshort s, GLshort t);
		 void glMultiTexCoord2svARB(GLenum target, GLshort *v);
		 void glMultiTexCoord3dARB(GLenum target, GLdouble s, GLdouble t, GLdouble r);
		 void glMultiTexCoord3dvARB(GLenum target, GLdouble *v);
		 void glMultiTexCoord3fARB(GLenum target, GLfloat s, GLfloat t, GLfloat r);
		 void glMultiTexCoord3fvARB(GLenum target, GLfloat *v);
		 void glMultiTexCoord3iARB(GLenum target, GLint s, GLint t, GLint r);
		 void glMultiTexCoord3ivARB(GLenum target, GLint *v);
		 void glMultiTexCoord3sARB(GLenum target, GLshort s, GLshort t, GLshort r);
		 void glMultiTexCoord3svARB(GLenum target, GLshort *v);
		 void glMultiTexCoord4dARB(GLenum target, GLdouble s, GLdouble t, GLdouble r, GLdouble q);
		 void glMultiTexCoord4dvARB(GLenum target, GLdouble *v);
		 void glMultiTexCoord4fARB(GLenum target, GLfloat s, GLfloat t, GLfloat r, GLfloat q);
		 void glMultiTexCoord4fvARB(GLenum target, GLfloat *v);
		 void glMultiTexCoord4iARB(GLenum target, GLint s, GLint t, GLint r, GLint q);
		 void glMultiTexCoord4ivARB(GLenum target, GLint *v);
		 void glMultiTexCoord4sARB(GLenum target, GLshort s, GLshort t, GLshort r, GLshort q);
		 void glMultiTexCoord4svARB(GLenum target, GLshort *v);
	}

	//GL_ARB_transpose_matrix
	version(GL_ARB_transpose_matrix)
	{
		 void glLoadTransposeMatrixfARB (GLfloat *m);
		 void glLoadTransposeMatrixdARB (GLdouble *m);
		 void glMultTransposeMatrixfARB (GLfloat *m);
		 void glMultTransposeMatrixdARB (GLdouble *m);
	}

	//GL_ARB_multisample
	version(GL_ARB_multisample)
	{
		 void glSampleCoverageARB(GLclampf value, GLboolean invert);
	}

	//GL_ARB_texture_env_add
	version(GL_ARB_texture_env_add)
{}

	//GL_ARB_texture_cube_map
	version(GL_ARB_texture_cube_map)
	{}

	//GL_ARB_texture_compression
	version(GL_ARB_texture_compression)
	{
		 void glCompressedTexImage3DARB(GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLsizei depth, GLint border, GLsizei imageSize, GLvoid *data);
		 void glCompressedTexImage2DARB(GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLint border, GLsizei imageSize, GLvoid *data);
		 void glCompressedTexImage1DARB(GLenum target, GLint level, GLenum internalformat, GLsizei width, GLint border, GLsizei imageSize, GLvoid *data);
		 void glCompressedTexSubImage3DARB(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLsizei width, GLsizei height, GLsizei depth, GLenum format, GLsizei imageSize, GLvoid *data);
		 void glCompressedTexSubImage2DARB(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLsizei width, GLsizei height, GLenum format, GLsizei imageSize, GLvoid *data);
		 void glCompressedTexSubImage1DARB(GLenum target, GLint level, GLint xoffset, GLsizei width, GLenum format, GLsizei imageSize, GLvoid *data);
		 void glGetCompressedTexImageARB(GLenum target, GLint level, GLvoid *img);
	}

	//GL_ARB_texture_border_clamp
	version(GL_ARB_texture_border_clamp)
{}

	//GL_ARB_point_parameters
	version(GL_ARB_point_parameters)
	{
		 void glPointParameterfARB(GLenum pname, GLfloat param);
		 void glPointParameterfvARB(GLenum pname, GLfloat *params);
	}

	//GL_ARB_vertex_blend
	version(GL_ARB_vertex_blend)
	{
		 void glWeightbvARB(GLint size, GLbyte *weights);
		 void glWeightsvARB(GLint size, GLshort *weights);
		 void glWeightivARB(GLint size, GLint *weights);
		 void glWeightfvARB(GLint size, GLfloat *weights);
		 void glWeightdvARB(GLint size, GLdouble *weights);
		 void glWeightubvARB(GLint size, GLubyte *weights);
		 void glWeightusvARB(GLint size, GLushort *weights);
		 void glWeightuivARB(GLint size, GLuint *weights);
		 void glWeightPointerARB(GLint size, GLenum type, GLsizei stride, GLvoid *pointer);
		 void glVertexBlendARB(GLint count);
	}

	//GL_ARB_matrix_palette
	version(GL_ARB_matrix_palette)
	{
		 void glCurrentPaletteMatrixARB(GLint index);
		 void glMatrixIndexubvARB(GLint size, GLubyte *indices);
		 void glMatrixIndexusvARB(GLint size, GLushort *indices);
		 void glMatrixIndexuivARB(GLint size, GLuint *indices);
		 void glMatrixIndexPointerARB(GLint size, GLenum type, GLsizei stride, GLvoid *pointer);
	}

	//GL_ARB_texture_env_combine
	version(GL_ARB_texture_env_combine)
{}

	//GL_ARB_texture_env_crossbar
	version(GL_ARB_texture_env_crossbar)
	{}

	//GL_ARB_texture_env_dot3
	version(GL_ARB_texture_env_dot3)
	{}

	//GL_ARB_texture_mirrored_repeat
	version(GL_ARB_texture_mirrored_repeat)
	{}

	//GL_ARB_depth_texture
	version(GL_ARB_depth_texture)
	{}

	//GL_ARB_shadow
	version(GL_ARB_shadow)
	{}

	//GL_ARB_shadow_ambient
	version(GL_ARB_shadow_ambient)
	{}

	//GL_ARB_window_pos
	version(GL_ARB_window_pos)
	{
		 void glWindowPos2dARB(GLdouble x, GLdouble y);
		 void glWindowPos2dvARB (GLdouble *v);
		 void glWindowPos2fARB(GLfloat x, GLfloat y);
		 void glWindowPos2fvARB (GLfloat *v);
		 void glWindowPos2iARB(GLint x, GLint y);
		 void glWindowPos2ivARB (GLint *v);
		 void glWindowPos2sARB(GLshort x, GLshort y);
		 void glWindowPos2svARB (GLshort *v);
		 void glWindowPos3dARB(GLdouble x, GLdouble y, GLdouble z);
		 void glWindowPos3dvARB (GLdouble *v);
		 void glWindowPos3fARB(GLfloat x, GLfloat y, GLfloat z);
		 void glWindowPos3fvARB (GLfloat *v);
		 void glWindowPos3iARB(GLint x, GLint y, GLint z);
		 void glWindowPos3ivARB (GLint *v);
		 void glWindowPos3sARB(GLshort x, GLshort y, GLshort z);
		 void glWindowPos3svARB (GLshort *v);
	}

	//GL_ARB_vertex_program
	version(GL_ARB_vertex_program)
	{
		 void glVertexAttrib1dARB(GLuint index, GLdouble x);
		 void glVertexAttrib1dvARB(GLuint index, GLdouble *v);
		 void glVertexAttrib1fARB(GLuint index, GLfloat x);
		 void glVertexAttrib1fvARB(GLuint index, GLfloat *v);
		 void glVertexAttrib1sARB(GLuint index, GLshort x);
		 void glVertexAttrib1svARB(GLuint index, GLshort *v);
		 void glVertexAttrib2dARB(GLuint index, GLdouble x, GLdouble y);
		 void glVertexAttrib2dvARB(GLuint index, GLdouble *v);
		 void glVertexAttrib2fARB(GLuint index, GLfloat x, GLfloat y);
		 void glVertexAttrib2fvARB(GLuint index, GLfloat *v);
		 void glVertexAttrib2sARB(GLuint index, GLshort x, GLshort y);
		 void glVertexAttrib2svARB(GLuint index, GLshort *v);
		 void glVertexAttrib3dARB(GLuint index, GLdouble x, GLdouble y, GLdouble z);
		 void glVertexAttrib3dvARB(GLuint index, GLdouble *v);
		 void glVertexAttrib3fARB(GLuint index, GLfloat x, GLfloat y, GLfloat z);
		 void glVertexAttrib3fvARB(GLuint index, GLfloat *v);
		 void glVertexAttrib3sARB(GLuint index, GLshort x, GLshort y, GLshort z);
		 void glVertexAttrib3svARB(GLuint index, GLshort *v);
		 void glVertexAttrib4NbvARB(GLuint index, GLbyte *v);
		 void glVertexAttrib4NivARB(GLuint index, GLint *v);
		 void glVertexAttrib4NsvARB(GLuint index, GLshort *v);
		 void glVertexAttrib4NubARB(GLuint index, GLubyte x, GLubyte y, GLubyte z, GLubyte w);
		 void glVertexAttrib4NubvARB(GLuint index, GLubyte *v);
		 void glVertexAttrib4NuivARB(GLuint index, GLuint *v);
		 void glVertexAttrib4NusvARB(GLuint index, GLushort *v);
		 void glVertexAttrib4bvARB(GLuint index, GLbyte *v);
		 void glVertexAttrib4dARB(GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w);
		 void glVertexAttrib4dvARB(GLuint index, GLdouble *v);
		 void glVertexAttrib4fARB(GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w);
		 void glVertexAttrib4fvARB(GLuint index, GLfloat *v);
		 void glVertexAttrib4ivARB(GLuint index, GLint *v);
		 void glVertexAttrib4sARB(GLuint index, GLshort x, GLshort y, GLshort z, GLshort w);
		 void glVertexAttrib4svARB(GLuint index, GLshort *v);
		 void glVertexAttrib4ubvARB(GLuint index, GLubyte *v);
		 void glVertexAttrib4uivARB(GLuint index, GLuint *v);
		 void glVertexAttrib4usvARB(GLuint index, GLushort *v);
		 void glVertexAttribPointerARB(GLuint index, GLint size, GLenum type, GLboolean normalized, GLsizei stride, GLvoid *pointer);
		 void glEnableVertexAttribArrayARB(GLuint index);
		 void glDisableVertexAttribArrayARB(GLuint index);
		 void glProgramStringARB(GLenum target, GLenum format, GLsizei len, GLvoid *string);
		 void glBindProgramARB(GLenum target, GLuint program);
		 void glDeleteProgramsARB(GLsizei n, GLuint *programs);
		 void glGenProgramsARB(GLsizei n, GLuint *programs);
		 void glProgramEnvParameter4dARB(GLenum target, GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w);
		 void glProgramEnvParameter4dvARB(GLenum target, GLuint index, GLdouble *params);
		 void glProgramEnvParameter4fARB(GLenum target, GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w);
		 void glProgramEnvParameter4fvARB(GLenum target, GLuint index, GLfloat *params);
		 void glProgramLocalParameter4dARB(GLenum target, GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w);
		 void glProgramLocalParameter4dvARB(GLenum target, GLuint index, GLdouble *params);
		 void glProgramLocalParameter4fARB(GLenum target, GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w);
		 void glProgramLocalParameter4fvARB(GLenum target, GLuint index, GLfloat *params);
		 void glGetProgramEnvParameterdvARB(GLenum target, GLuint index, GLdouble *params);
		 void glGetProgramEnvParameterfvARB(GLenum target, GLuint index, GLfloat *params);
		 void glGetProgramLocalParameterdvARB(GLenum target, GLuint index, GLdouble *params);
		 void glGetProgramLocalParameterfvARB(GLenum target, GLuint index, GLfloat *params);
		 void glGetProgramivARB(GLenum target, GLenum pname, GLint *params);
		 void glGetProgramStringARB(GLenum target, GLenum pname, GLvoid *string);
		 void glGetVertexAttribdvARB(GLuint index, GLenum pname, GLdouble *params);
		 void glGetVertexAttribfvARB(GLuint index, GLenum pname, GLfloat *params);
		 void glGetVertexAttribivARB(GLuint index, GLenum pname, GLint *params);
		 void glGetVertexAttribPointervARB(GLuint index, GLenum pname, GLvoid* *pointer);
		 GLboolean glIsProgramARB(GLuint program);
	}

	//GL_ARB_fragment_program
	version(GL_ARB_fragment_program)
{}

	//GL_ARB_vertex_buffer_object
	version(GL_ARB_vertex_buffer_object)
	{
		 void glBindBufferARB(GLenum target, GLuint buffer);
		 void glDeleteBuffersARB(GLsizei n, GLuint *buffers);
		 void glGenBuffersARB(GLsizei n, GLuint *buffers);
		 GLboolean glIsBufferARB(GLuint buffer);
		 void glBufferDataARB(GLenum target, GLsizeiptrARB size, GLvoid *data, GLenum usage);
		 void glBufferSubDataARB(GLenum target, GLintptrARB offset, GLsizeiptrARB size, GLvoid *data);
		 void glGetBufferSubDataARB(GLenum target, GLintptrARB offset, GLsizeiptrARB size, GLvoid *data);
		 GLvoid* glMapBufferARB(GLenum target, GLenum access);
		 GLboolean glUnmapBufferARB(GLenum target);
		 void glGetBufferParameterivARB(GLenum target, GLenum pname, GLint *params);
		 void glGetBufferPointervARB(GLenum target, GLenum pname, GLvoid* *params);
	}

	//GL_ARB_occlusion_query
	version(GL_ARB_occlusion_query)
	{
		 void glGenQueriesARB(GLsizei n, GLuint *ids);
		 void glDeleteQueriesARB(GLsizei n, GLuint *ids);
		 GLboolean glIsQueryARB(GLuint id);
		 void glBeginQueryARB(GLenum target, GLuint id);
		 void glEndQueryARB(GLenum target);
		 void glGetQueryivARB(GLenum target, GLenum pname, GLint *params);
		 void glGetQueryObjectivARB(GLuint id, GLenum pname, GLint *params);
		 void glGetQueryObjectuivARB(GLuint id, GLenum pname, GLuint *params);
	}

	//GL_ARB_shader_objects
	version(GL_ARB_shader_objects)
	{
		 void glDeleteObjectARB(GLhandleARB obj);
		 GLhandleARB glGetHandleARB(GLenum pname);
		 void glDetachObjectARB(GLhandleARB containerObj, GLhandleARB attachedObj);
		 GLhandleARB glCreateShaderObjectARB(GLenum shaderType);
		 void glShaderSourceARB(GLhandleARB shaderObj, GLsizei count, GLcharARB* *string, GLint *length);
		 void glCompileShaderARB(GLhandleARB shaderObj);
		 GLhandleARB glCreateProgramObjectARB();
		 void glAttachObjectARB(GLhandleARB containerObj, GLhandleARB obj);
		 void glLinkProgramARB(GLhandleARB programObj);
		 void glUseProgramObjectARB(GLhandleARB programObj);
		 void glValidateProgramARB(GLhandleARB programObj);
		 void glUniform1fARB(GLint location, GLfloat v0);
		 void glUniform2fARB(GLint location, GLfloat v0, GLfloat v1);
		 void glUniform3fARB(GLint location, GLfloat v0, GLfloat v1, GLfloat v2);
		 void glUniform4fARB(GLint location, GLfloat v0, GLfloat v1, GLfloat v2, GLfloat v3);
		 void glUniform1iARB(GLint location, GLint v0);
		 void glUniform2iARB(GLint location, GLint v0, GLint v1);
		 void glUniform3iARB(GLint location, GLint v0, GLint v1, GLint v2);
		 void glUniform4iARB(GLint location, GLint v0, GLint v1, GLint v2, GLint v3);
		 void glUniform1fvARB(GLint location, GLsizei count, GLfloat *value);
		 void glUniform2fvARB(GLint location, GLsizei count, GLfloat *value);
		 void glUniform3fvARB(GLint location, GLsizei count, GLfloat *value);
		 void glUniform4fvARB(GLint location, GLsizei count, GLfloat *value);
		 void glUniform1ivARB(GLint location, GLsizei count, GLint *value);
		 void glUniform2ivARB(GLint location, GLsizei count, GLint *value);
		 void glUniform3ivARB(GLint location, GLsizei count, GLint *value);
		 void glUniform4ivARB(GLint location, GLsizei count, GLint *value);
		 void glUniformMatrix2fvARB(GLint location, GLsizei count, GLboolean transpose, GLfloat *value);
		 void glUniformMatrix3fvARB(GLint location, GLsizei count, GLboolean transpose, GLfloat *value);
		 void glUniformMatrix4fvARB(GLint location, GLsizei count, GLboolean transpose, GLfloat *value);
		 void glGetObjectParameterfvARB(GLhandleARB obj, GLenum pname, GLfloat *params);
		 void glGetObjectParameterivARB(GLhandleARB obj, GLenum pname, GLint *params);
		 void glGetInfoLogARB(GLhandleARB obj, GLsizei maxLength, GLsizei *length, GLcharARB *infoLog);
		 void glGetAttachedObjectsARB(GLhandleARB containerObj, GLsizei maxCount, GLsizei *count, GLhandleARB *obj);
		 GLint glGetUniformLocationARB(GLhandleARB programObj, GLcharARB *name);
		 void glGetActiveUniformARB(GLhandleARB programObj, GLuint index, GLsizei maxLength, GLsizei *length, GLint *size, GLenum *type, GLcharARB *name);
		 void glGetUniformfvARB(GLhandleARB programObj, GLint location, GLfloat *params);
		 void glGetUniformivARB(GLhandleARB programObj, GLint location, GLint *params);
		 void glGetShaderSourceARB(GLhandleARB obj, GLsizei maxLength, GLsizei *length, GLcharARB *source);
	}

	//GL_ARB_vertex_shader
	version(GL_ARB_vertex_shader)
	{
		 void glBindAttribLocationARB(GLhandleARB programObj, GLuint index, GLcharARB *name);
		 void glGetActiveAttribARB(GLhandleARB programObj, GLuint index, GLsizei maxLength, GLsizei *length, GLint *size, GLenum *type, GLcharARB *name);
		 GLint glGetAttribLocationARB(GLhandleARB programObj, GLcharARB *name);
	}

	//GL_ARB_fragment_shader
	version(GL_ARB_fragment_shader)
{}

	//GL_ARB_shading_language_100
	version(GL_ARB_shading_language_100)
	{}

	//GL_ARB_texture_non_power_of_two
	version(GL_ARB_texture_non_power_of_two)
	{}

	//GL_ARB_point_sprite
	version(GL_ARB_point_sprite)
	{}

	//GL_EXT_abgr
	version(GL_EXT_abgr)
	{}

	//GL_EXT_blend_color
	version(GL_EXT_blend_color)
	{
		 void glBlendColorEXT(GLclampf red, GLclampf green, GLclampf blue, GLclampf alpha);
	}

	//GL_EXT_polygon_offset
	version(GL_EXT_polygon_offset)
	{
		 void glPolygonOffsetEXT(GLfloat factor, GLfloat bias);
	}

	//GL_EXT_texture
	version(GL_EXT_texture)
{}

	//GL_EXT_texture3D
	version(GL_EXT_texture3D)
	{
		 void glTexImage3DEXT(GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLsizei depth, GLint border, GLenum format, GLenum type, GLvoid *pixels);
		 void glTexSubImage3DEXT(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLsizei width, GLsizei height, GLsizei depth, GLenum format, GLenum type, GLvoid *pixels);
	}

	//GL_SGIS_texture_filter4
	version(GL_SGIS_texture_filter4)
	{
		 void glGetTexFilterFuncSGIS(GLenum target, GLenum filter, GLfloat *weights);
		 void glTexFilterFuncSGIS(GLenum target, GLenum filter, GLsizei n, GLfloat *weights);
	}

	//GL_EXT_subtexture
	version(GL_EXT_subtexture)
	{
		 void glTexSubImage1DEXT(GLenum target, GLint level, GLint xoffset, GLsizei width, GLenum format, GLenum type, GLvoid *pixels);
		 void glTexSubImage2DEXT(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLsizei width, GLsizei height, GLenum format, GLenum type, GLvoid *pixels);
	}

	//GL_EXT_copy_texture
	version(GL_EXT_copy_texture)
	{
		 void glCopyTexImage1DEXT(GLenum target, GLint level, GLenum internalformat, GLint x, GLint y, GLsizei width, GLint border);
		 void glCopyTexImage2DEXT(GLenum target, GLint level, GLenum internalformat, GLint x, GLint y, GLsizei width, GLsizei height, GLint border);
		 void glCopyTexSubImage1DEXT(GLenum target, GLint level, GLint xoffset, GLint x, GLint y, GLsizei width);
		 void glCopyTexSubImage2DEXT(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint x, GLint y, GLsizei width, GLsizei height);
		 void glCopyTexSubImage3DEXT(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLint x, GLint y, GLsizei width, GLsizei height);
	}

	//GL_EXT_histogram
	version(GL_EXT_histogram)
	{
		 void glGetHistogramEXT(GLenum target, GLboolean reset, GLenum format, GLenum type, GLvoid *values);
		 void glGetHistogramParameterfvEXT(GLenum target, GLenum pname, GLfloat *params);
		 void glGetHistogramParameterivEXT(GLenum target, GLenum pname, GLint *params);
		 void glGetMinmaxEXT(GLenum target, GLboolean reset, GLenum format, GLenum type, GLvoid *values);
		 void glGetMinmaxParameterfvEXT(GLenum target, GLenum pname, GLfloat *params);
		 void glGetMinmaxParameterivEXT(GLenum target, GLenum pname, GLint *params);
		 void glHistogramEXT(GLenum target, GLsizei width, GLenum internalformat, GLboolean sink);
		 void glMinmaxEXT(GLenum target, GLenum internalformat, GLboolean sink);
		 void glResetHistogramEXT(GLenum target);
		 void glResetMinmaxEXT(GLenum target);
	}

	//GL_EXT_convolution
	version(GL_EXT_convolution)
	{
		 void glConvolutionFilter1DEXT(GLenum target, GLenum internalformat, GLsizei width, GLenum format, GLenum type, GLvoid *image);
		 void glConvolutionFilter2DEXT(GLenum target, GLenum internalformat, GLsizei width, GLsizei height, GLenum format, GLenum type, GLvoid *image);
		 void glConvolutionParameterfEXT(GLenum target, GLenum pname, GLfloat params);
		 void glConvolutionParameterfvEXT(GLenum target, GLenum pname, GLfloat *params);
		 void glConvolutionParameteriEXT(GLenum target, GLenum pname, GLint params);
		 void glConvolutionParameterivEXT(GLenum target, GLenum pname, GLint *params);
		 void glCopyConvolutionFilter1DEXT(GLenum target, GLenum internalformat, GLint x, GLint y, GLsizei width);
		 void glCopyConvolutionFilter2DEXT(GLenum target, GLenum internalformat, GLint x, GLint y, GLsizei width, GLsizei height);
		 void glGetConvolutionFilterEXT(GLenum target, GLenum format, GLenum type, GLvoid *image);
		 void glGetConvolutionParameterfvEXT(GLenum target, GLenum pname, GLfloat *params);
		 void glGetConvolutionParameterivEXT(GLenum target, GLenum pname, GLint *params);
		 void glGetSeparableFilterEXT(GLenum target, GLenum format, GLenum type, GLvoid *row, GLvoid *column, GLvoid *span);
		 void glSeparableFilter2DEXT(GLenum target, GLenum internalformat, GLsizei width, GLsizei height, GLenum format, GLenum type, GLvoid *row, GLvoid *column);
	}

	//GL_SGI_color_matrix
	version(GL_SGI_color_matrix)
{}

	//GL_SGI_color_table
	version(GL_SGI_color_table)
	{
		 void glColorTableSGI(GLenum target, GLenum internalformat, GLsizei width, GLenum format, GLenum type, GLvoid *table);
		 void glColorTableParameterfvSGI(GLenum target, GLenum pname, GLfloat *params);
		 void glColorTableParameterivSGI(GLenum target, GLenum pname, GLint *params);
		 void glCopyColorTableSGI(GLenum target, GLenum internalformat, GLint x, GLint y, GLsizei width);
		 void glGetColorTableSGI(GLenum target, GLenum format, GLenum type, GLvoid *table);
		 void glGetColorTableParameterfvSGI(GLenum target, GLenum pname, GLfloat *params);
		 void glGetColorTableParameterivSGI(GLenum target, GLenum pname, GLint *params);
	}

	//GL_SGIS_pixel_texture
	version(GL_SGIS_pixel_texture)
	{
		 void glPixelTexGenParameteriSGIS(GLenum pname, GLint param);
		 void glPixelTexGenParameterivSGIS(GLenum pname, GLint *params);
		 void glPixelTexGenParameterfSGIS(GLenum pname, GLfloat param);
		 void glPixelTexGenParameterfvSGIS(GLenum pname, GLfloat *params);
		 void glGetPixelTexGenParameterivSGIS(GLenum pname, GLint *params);
		 void glGetPixelTexGenParameterfvSGIS(GLenum pname, GLfloat *params);
	}

	//GL_SGIX_pixel_texture
	version(GL_SGIX_pixel_texture)
	{
		 void glPixelTexGenSGIX(GLenum mode);
	}

	//GL_SGIS_texture4D
	version(GL_SGIS_texture4D)
	{
		 void glTexImage4DSGIS(GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLsizei depth, GLsizei size4d, GLint border, GLenum format, GLenum type, GLvoid *pixels);
		 void glTexSubImage4DSGIS(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint zoffset, GLint woffset, GLsizei width, GLsizei height, GLsizei depth, GLsizei size4d, GLenum format, GLenum type, GLvoid *pixels);
	}

	//GL_SGI_texture_color_table
	version(GL_SGI_texture_color_table)
{}

	//GL_EXT_cmyka
	version(GL_EXT_cmyka)
	{}

	//GL_EXT_texture_object
	version(GL_EXT_texture_object)
	{
		 GLboolean glAreTexturesResidentEXT(GLsizei n, GLuint *textures, GLboolean *residences);
		 void glBindTextureEXT(GLenum target, GLuint texture);
		 void glDeleteTexturesEXT(GLsizei n, GLuint *textures);
		 void glGenTexturesEXT(GLsizei n, GLuint *textures);
		 GLboolean glIsTextureEXT(GLuint texture);
		 void glPrioritizeTexturesEXT(GLsizei n, GLuint *textures, GLclampf *priorities);
	}

	//GL_SGIS_detail_texture
	version(GL_SGIS_detail_texture)
	{
		 void glDetailTexFuncSGIS(GLenum target, GLsizei n, GLfloat *points);
		 void glGetDetailTexFuncSGIS(GLenum target, GLfloat *points);
	}

	//GL_SGIS_sharpen_texture
	version(GL_SGIS_sharpen_texture)
	{
		 void glSharpenTexFuncSGIS(GLenum target, GLsizei n, GLfloat *points);
		 void glGetSharpenTexFuncSGIS(GLenum target, GLfloat *points);
	}

	//GL_EXT_packed_pixels
	version(GL_EXT_packed_pixels)
{}

	//GL_SGIS_texture_lod
	version(GL_SGIS_texture_lod)
	{}

	//GL_SGIS_multisample
	version(GL_SGIS_multisample)
	{
		 void glSampleMaskSGIS(GLclampf value, GLboolean invert);
		 void glSamplePatternSGIS(GLenum pattern);
	}

	//GL_EXT_rescale_normal
	version(GL_EXT_rescale_normal)
{}

	//GL_EXT_vertex_array
	version(GL_EXT_vertex_array)
	{
		 void glArrayElementEXT(GLint i);
		 void glColorPointerEXT(GLint size, GLenum type, GLsizei stride, GLsizei count, GLvoid *pointer);
		 void glDrawArraysEXT(GLenum mode, GLint first, GLsizei count);
		 void glEdgeFlagPointerEXT(GLsizei stride, GLsizei count, GLboolean *pointer);
		 void glGetPointervEXT(GLenum pname, GLvoid* *params);
		 void glIndexPointerEXT(GLenum type, GLsizei stride, GLsizei count, GLvoid *pointer);
		 void glNormalPointerEXT(GLenum type, GLsizei stride, GLsizei count, GLvoid *pointer);
		 void glTexCoordPointerEXT(GLint size, GLenum type, GLsizei stride, GLsizei count, GLvoid *pointer);
		 void glVertexPointerEXT(GLint size, GLenum type, GLsizei stride, GLsizei count, GLvoid *pointer);
	}

	//GL_EXT_misc_attribute
	version(GL_EXT_misc_attribute)
{}

	//GL_SGIS_generate_mipmap
	version(GL_SGIS_generate_mipmap)
	{}

	//GL_SGIX_clipmap
	version(GL_SGIX_clipmap)
	{}

	//GL_SGIX_shadow
	version(GL_SGIX_shadow)
	{}

	//GL_SGIS_texture_edge_clamp
	version(GL_SGIS_texture_edge_clamp)
	{}

	//GL_EXT_blend_minmax
	version(GL_EXT_blend_minmax)
	{
		 void glBlendEquationEXT(GLenum mode);
	}

	//GL_EXT_blend_subtract
	version(GL_EXT_blend_subtract)
{}

	//GL_EXT_blend_logic_op
	version(GL_EXT_blend_logic_op)
	{}

	//GL_SGIX_interlace
	version(GL_SGIX_interlace)
	{}

	//GL_SGIX_pixel_tiles
	version(GL_SGIX_pixel_tiles)
	{}

	//GL_SGIS_texture_select
	version(GL_SGIS_texture_select)
	{}

	//GL_SGIX_sprite
	version(GL_SGIX_sprite)
	{
		 void glSpriteParameterfSGIX(GLenum pname, GLfloat param);
		 void glSpriteParameterfvSGIX(GLenum pname, GLfloat *params);
		 void glSpriteParameteriSGIX(GLenum pname, GLint param);
		 void glSpriteParameterivSGIX(GLenum pname, GLint *params);
	}

	//GL_SGIX_texture_multi_buffer
	version(GL_SGIX_texture_multi_buffer)
{}

	//GL_EXT_point_parameters
	version(GL_EXT_point_parameters)
	{
		 void glPointParameterfEXT(GLenum pname, GLfloat param);
		 void glPointParameterfvEXT(GLenum pname, GLfloat *params);
	}

	//GL_SGIS_point_parameters
	version(GL_SGIS_point_parameters)
	{
		 void glPointParameterfSGIS(GLenum pname, GLfloat param);
		 void glPointParameterfvSGIS(GLenum pname, GLfloat *params);
	}

	//GL_SGIX_instruments
	version(GL_SGIX_instruments)
	{
		 GLint glGetInstrumentsSGIX();
		 void glInstrumentsBufferSGIX(GLsizei size, GLint *buffer);
		 GLint glPollInstrumentsSGIX(GLint *marker_p);
		 void glReadInstrumentsSGIX(GLint marker);
		 void XPFNGLSTARTINSTRUMENTSSGIXPROC();
		 void glStopInstrumentsSGIX(GLint marker);
	}

	//GL_SGIX_texture_scale_bias
	version(GL_SGIX_texture_scale_bias)
{}

	//GL_SGIX_framezoom
	version(GL_SGIX_framezoom)
	{
		 void glFrameZoomSGIX(GLint factor);
	}

	//GL_SGIX_tag_sample_buffer
	version(GL_SGIX_tag_sample_buffer)
	{
		 void glTagSampleBufferSGIX();
	}

	//GL_FfdMaskSGIX
	version(GL_FfdMaskSGIX)
{}

	//GL_SGIX_polynomial_ffd
	version(GL_SGIX_polynomial_ffd)
	{
		 void glDeformationMap3dSGIX(GLenum target, GLdouble u1, GLdouble u2, GLint ustride, GLint uorder, GLdouble v1, GLdouble v2, GLint vstride, GLint vorder, GLdouble w1, GLdouble w2, GLint wstride, GLint worder, GLdouble *points);
		 void glDeformationMap3fSGIX(GLenum target, GLfloat u1, GLfloat u2, GLint ustride, GLint uorder, GLfloat v1, GLfloat v2, GLint vstride, GLint vorder, GLfloat w1, GLfloat w2, GLint wstride, GLint worder, GLfloat *points);
		 void glDeformSGIX(GLbitfield mask);
		 void glLoadIdentityDeformationMapSGIX(GLbitfield mask);
	}

	//GL_SGIX_reference_plane
	version(GL_SGIX_reference_plane)
	{
		 void glReferencePlaneSGIX (GLdouble *equation);
	}

	//GL_SGIX_flush_raster
	version(GL_SGIX_flush_raster)
	{
		 void glFlushRasterSGIX();
	}

	//GL_SGIX_depth_texture
	version(GL_SGIX_depth_texture)
{}

	//GL_SGIS_fog_function
	version(GL_SGIS_fog_function)
	{
		 void glFogFuncSGIS(GLsizei n, GLfloat *points);
		 void glGetFogFuncSGIS(GLfloat *points);
	}

	//GL_SGIX_fog_offset
	version(GL_SGIX_fog_offset)
{}

	//GL_HP_image_transform
	version(GL_HP_image_transform)
	{
		 void glImageTransformParameteriHP(GLenum target, GLenum pname, GLint param);
		 void glImageTransformParameterfHP(GLenum target, GLenum pname, GLfloat param);
		 void glImageTransformParameterivHP(GLenum target, GLenum pname, GLint *params);
		 void glImageTransformParameterfvHP(GLenum target, GLenum pname, GLfloat *params);
		 void glGetImageTransformParameterivHP(GLenum target, GLenum pname, GLint *params);
		 void glGetImageTransformParameterfvHP(GLenum target, GLenum pname, GLfloat *params);
	}

	//GL_HP_convolution_border_modes
	version(GL_HP_convolution_border_modes)
{}

	//GL_INGR_palette_buffer
	version(GL_INGR_palette_buffer)
	{}

	//GL_SGIX_texture_add_env
	version(GL_SGIX_texture_add_env)
	{}

	//GL_EXT_color_subtable
	version(GL_EXT_color_subtable)
	{
		 void glColorSubTableEXT(GLenum target, GLsizei start, GLsizei count, GLenum format, GLenum type, GLvoid *data);
		 void glCopyColorSubTableEXT(GLenum target, GLsizei start, GLint x, GLint y, GLsizei width);
	}

	//GL_PGI_vertex_hints
	version(GL_PGI_vertex_hints)
{}

	//GL_PGI_misc_hints
	version(GL_PGI_misc_hints)
	{
		 void glHintPGI(GLenum target, GLint mode);
	}

	//GL_EXT_paletted_texture
	version(GL_EXT_paletted_texture)
	{
		 void glColorTableEXT(GLenum target, GLenum internalFormat, GLsizei width, GLenum format, GLenum type, GLvoid *table);
		 void glGetColorTableEXT(GLenum target, GLenum format, GLenum type, GLvoid *data);
		 void glGetColorTableParameterivEXT(GLenum target, GLenum pname, GLint *params);
		 void glGetColorTableParameterfvEXT(GLenum target, GLenum pname, GLfloat *params);
	}

	//GL_EXT_clip_volume_hint
	version(GL_EXT_clip_volume_hint)
{}

	//GL_SGIX_list_priority
	version(GL_SGIX_list_priority)
	{
		 void glGetListParameterfvSGIX(GLuint list, GLenum pname, GLfloat *params);
		 void glGetListParameterivSGIX(GLuint list, GLenum pname, GLint *params);
		 void glListParameterfSGIX(GLuint list, GLenum pname, GLfloat param);
		 void glListParameterfvSGIX(GLuint list, GLenum pname, GLfloat *params);
		 void glListParameteriSGIX(GLuint list, GLenum pname, GLint param);
		 void glListParameterivSGIX(GLuint list, GLenum pname, GLint *params);
	}

	//GL_SGIX_ir_instrument1
	version(GL_SGIX_ir_instrument1)
{}

	//GL_SGIX_calligraphic_fragment
	version(GL_SGIX_calligraphic_fragment)
	{}

	//GL_SGIX_texture_lod_bias
	version(GL_SGIX_texture_lod_bias)
	{}

	//GL_SGIX_shadow_ambient
	version(GL_SGIX_shadow_ambient)
	{}

	//GL_EXT_index_texture
	version(GL_EXT_index_texture)
	{}

	//GL_EXT_index_material
	version(GL_EXT_index_material)
	{
		 void glIndexMaterialEXT(GLenum face, GLenum mode);
	}

	//GL_EXT_index_func
	version(GL_EXT_index_func)
	{
		 void glIndexFuncEXT(GLenum func, GLclampf r);
	}

	//GL_EXT_index_array_formats
	version(GL_EXT_index_array_formats)
{}

	//GL_EXT_compiled_vertex_array
	version(GL_EXT_compiled_vertex_array)
	{
		 void glLockArraysEXT(GLint first, GLsizei count);
		 void glUnlockArraysEXT();
	}

	//GL_EXT_cull_vertex
	version(GL_EXT_cull_vertex)
	{
		 void glCullParameterdvEXT(GLenum pname, GLdouble *params);
		 void glCullParameterfvEXT(GLenum pname, GLfloat *params);
	}

	//GL_SGIX_ycrcb
	version(GL_SGIX_ycrcb)
{}

	//GL_SGIX_fragment_lighting
	version(GL_SGIX_fragment_lighting)
	{
		 void glFragmentColorMaterialSGIX(GLenum face, GLenum mode);
		 void glFragmentLightfSGIX(GLenum light, GLenum pname, GLfloat param);
		 void glFragmentLightfvSGIX(GLenum light, GLenum pname, GLfloat *params);
		 void glFragmentLightiSGIX(GLenum light, GLenum pname, GLint param);
		 void glFragmentLightivSGIX(GLenum light, GLenum pname, GLint *params);
		 void glFragmentLightModelfSGIX(GLenum pname, GLfloat param);
		 void glFragmentLightModelfvSGIX(GLenum pname, GLfloat *params);
		 void glFragmentLightModeliSGIX(GLenum pname, GLint param);
		 void glFragmentLightModelivSGIX(GLenum pname, GLint *params);
		 void glFragmentMaterialfSGIX(GLenum face, GLenum pname, GLfloat param);
		 void glFragmentMaterialfvSGIX(GLenum face, GLenum pname, GLfloat *params);
		 void glFragmentMaterialiSGIX(GLenum face, GLenum pname, GLint param);
		 void glFragmentMaterialivSGIX(GLenum face, GLenum pname, GLint *params);
		 void glGetFragmentLightfvSGIX(GLenum light, GLenum pname, GLfloat *params);
		 void glGetFragmentLightivSGIX(GLenum light, GLenum pname, GLint *params);
		 void glGetFragmentMaterialfvSGIX(GLenum face, GLenum pname, GLfloat *params);
		 void glGetFragmentMaterialivSGIX(GLenum face, GLenum pname, GLint *params);
		 void glLightEnviSGIX(GLenum pname, GLint param);
	}

	//GL_IBM_rasterpos_clip
	version(GL_IBM_rasterpos_clip)
{}

	//GL_HP_texture_lighting
	version(GL_HP_texture_lighting)
	{}

	//GL_EXT_draw_range_elements
	version(GL_EXT_draw_range_elements)
	{
		 void glDrawRangeElementsEXT(GLenum mode, GLuint start, GLuint end, GLsizei count, GLenum type, GLvoid *indices);
	}

	//GL_WIN_phong_shading
	version(GL_WIN_phong_shading)
{}

	//GL_WIN_specular_fog
	version(GL_WIN_specular_fog)
	{}

	//GL_EXT_light_texture
	version(GL_EXT_light_texture)
	{
		 void glApplyTextureEXT(GLenum mode);
		 void glTextureLightEXT(GLenum pname);
		 void glTextureMaterialEXT(GLenum face, GLenum mode);
	}

	//GL_SGIX_blend_alpha_minmax
	version(GL_SGIX_blend_alpha_minmax)
{}

	//GL_SGIX_impact_pixel_texture
	version(GL_SGIX_impact_pixel_texture)
	{}

	//GL_EXT_bgra
	version(GL_EXT_bgra)
	{}

	//GL_SGIX_async
	version(GL_SGIX_async)
	{
		 void glAsyncMarkerSGIX(GLuint marker);
		 GLint glFinishAsyncSGIX(GLuint *markerp);
		 GLint glPollAsyncSGIX(GLuint *markerp);
		 GLuint glGenAsyncMarkersSGIX(GLsizei range);
		 void glDeleteAsyncMarkersSGIX(GLuint marker, GLsizei range);
		 GLboolean glIsAsyncMarkerSGIX(GLuint marker);
	}

	//GL_SGIX_async_pixel
	version(GL_SGIX_async_pixel)
{}

	//GL_SGIX_async_histogram
	version(GL_SGIX_async_histogram)
	{}

	//GL_INTEL_texture_scissor
	version(GL_INTEL_texture_scissor)
	{}

	//GL_INTEL_parallel_arrays
	version(GL_INTEL_parallel_arrays)
	{
		 void glVertexPointervINTEL(GLint size, GLenum type, GLvoid* *pointer);
		 void glNormalPointervINTEL(GLenum type, GLvoid* *pointer);
		 void glColorPointervINTEL(GLint size, GLenum type, GLvoid* *pointer);
		 void glTexCoordPointervINTEL(GLint size, GLenum type, GLvoid* *pointer);
	}

	//GL_HP_occlusion_test
	version(GL_HP_occlusion_test)
{}

	//GL_EXT_pixel_transform
	version(GL_EXT_pixel_transform)
	{
		 void glPixelTransformParameteriEXT(GLenum target, GLenum pname, GLint param);
		 void glPixelTransformParameterfEXT(GLenum target, GLenum pname, GLfloat param);
		 void glPixelTransformParameterivEXT(GLenum target, GLenum pname, GLint *params);
		 void glPixelTransformParameterfvEXT(GLenum target, GLenum pname, GLfloat *params);
	}

	//GL_EXT_pixel_transform_color_table
	version(GL_EXT_pixel_transform_color_table)
{}

	//GL_EXT_shared_texture_palette
	version(GL_EXT_shared_texture_palette)
	{}

	//GL_EXT_separate_specular_color
	version(GL_EXT_separate_specular_color)
	{}

	//GL_EXT_secondary_color
	version(GL_EXT_secondary_color)
	{
		 void glSecondaryColor3bEXT(GLbyte red, GLbyte green, GLbyte blue);
		 void glSecondaryColor3bvEXT (GLbyte *v);
		 void glSecondaryColor3dEXT(GLdouble red, GLdouble green, GLdouble blue);
		 void glSecondaryColor3dvEXT (GLdouble *v);
		 void glSecondaryColor3fEXT(GLfloat red, GLfloat green, GLfloat blue);
		 void glSecondaryColor3fvEXT (GLfloat *v);
		 void glSecondaryColor3iEXT(GLint red, GLint green, GLint blue);
		 void glSecondaryColor3ivEXT (GLint *v);
		 void glSecondaryColor3sEXT(GLshort red, GLshort green, GLshort blue);
		 void glSecondaryColor3svEXT (GLshort *v);
		 void glSecondaryColor3ubEXT(GLubyte red, GLubyte green, GLubyte blue);
		 void glSecondaryColor3ubvEXT (GLubyte *v);
		 void glSecondaryColor3uiEXT(GLuint red, GLuint green, GLuint blue);
		 void glSecondaryColor3uivEXT (GLuint *v);
		 void glSecondaryColor3usEXT(GLushort red, GLushort green, GLushort blue);
		 void glSecondaryColor3usvEXT (GLushort *v);
		 void glSecondaryColorPointerEXT(GLint size, GLenum type, GLsizei stride, GLvoid *pointer);
	}

	//GL_EXT_texture_perturb_normal
	version(GL_EXT_texture_perturb_normal)
	{
		 void glTextureNormalEXT(GLenum mode);
	}

	//GL_EXT_multi_draw_arrays
	version(GL_EXT_multi_draw_arrays)
	{
		 void glMultiDrawArraysEXT(GLenum mode, GLint *first, GLsizei *count, GLsizei primcount);
		 void glMultiDrawElementsEXT(GLenum mode, GLsizei *count, GLenum type, GLvoid* *indices, GLsizei primcount);
	}

	//GL_EXT_fog_coord
	version(GL_EXT_fog_coord)
	{
		 void glFogCoordfEXT(GLfloat coord);
		 void glFogCoordfvEXT (GLfloat *coord);
		 void glFogCoorddEXT(GLdouble coord);
		 void glFogCoorddvEXT (GLdouble *coord);
		 void glFogCoordPointerEXT(GLenum type, GLsizei stride, GLvoid *pointer);
	}

	//GL_REND_screen_coordinates
	version(GL_REND_screen_coordinates)
{}

	//GL_EXT_coordinate_frame
	version(GL_EXT_coordinate_frame)
	{
		 void glTangent3bEXT(GLbyte tx, GLbyte ty, GLbyte tz);
		 void glTangent3bvEXT (GLbyte *v);
		 void glTangent3dEXT(GLdouble tx, GLdouble ty, GLdouble tz);
		 void glTangent3dvEXT (GLdouble *v);
		 void glTangent3fEXT(GLfloat tx, GLfloat ty, GLfloat tz);
		 void glTangent3fvEXT (GLfloat *v);
		 void glTangent3iEXT(GLint tx, GLint ty, GLint tz);
		 void glTangent3ivEXT (GLint *v);
		 void glTangent3sEXT(GLshort tx, GLshort ty, GLshort tz);
		 void glTangent3svEXT (GLshort *v);
		 void glBinormal3bEXT(GLbyte bx, GLbyte by, GLbyte bz);
		 void glBinormal3bvEXT (GLbyte *v);
		 void glBinormal3dEXT(GLdouble bx, GLdouble by, GLdouble bz);
		 void glBinormal3dvEXT (GLdouble *v);
		 void glBinormal3fEXT(GLfloat bx, GLfloat by, GLfloat bz);
		 void glBinormal3fvEXT (GLfloat *v);
		 void glBinormal3iEXT(GLint bx, GLint by, GLint bz);
		 void glBinormal3ivEXT (GLint *v);
		 void glBinormal3sEXT(GLshort bx, GLshort by, GLshort bz);
		 void glBinormal3svEXT (GLshort *v);
		 void glTangentPointerEXT(GLenum type, GLsizei stride, GLvoid *pointer);
		 void glBinormalPointerEXT(GLenum type, GLsizei stride, GLvoid *pointer);
	}

	//GL_EXT_texture_env_combine
	version(GL_EXT_texture_env_combine)
{}

	//GL_APPLE_specular_vector
	version(GL_APPLE_specular_vector)
	{}

	//GL_APPLE_transform_hint
	version(GL_APPLE_transform_hint)
	{}

	//GL_SGIX_fog_scale
	version(GL_SGIX_fog_scale)
	{}

	//GL_SUNX_constant_data
	version(GL_SUNX_constant_data)
	{
		 void glFinishTextureSUNX();
	}

	//GL_SUN_global_alpha
	version(GL_SUN_global_alpha)
	{
		 void glGlobalAlphaFactorbSUN(GLbyte factor);
		 void glGlobalAlphaFactorsSUN(GLshort factor);
		 void glGlobalAlphaFactoriSUN(GLint factor);
		 void glGlobalAlphaFactorfSUN(GLfloat factor);
		 void glGlobalAlphaFactordSUN(GLdouble factor);
		 void glGlobalAlphaFactorubSUN(GLubyte factor);
		 void glGlobalAlphaFactorusSUN(GLushort factor);
		 void glGlobalAlphaFactoruiSUN(GLuint factor);
	}

	//GL_SUN_triangle_list
	version(GL_SUN_triangle_list)
	{
		 void glReplacementCodeuiSUN(GLuint code);
		 void glReplacementCodeusSUN(GLushort code);
		 void glReplacementCodeubSUN(GLubyte code);
		 void glReplacementCodeuivSUN (GLuint *code);
		 void glReplacementCodeusvSUN (GLushort *code);
		 void glReplacementCodeubvSUN (GLubyte *code);
		 void glReplacementCodePointerSUN(GLenum type, GLsizei stride, GLvoid* *pointer);
	}

	//GL_SUN_vertex
	version(GL_SUN_vertex)
	{
		 void glColor4ubVertex2fSUN(GLubyte r, GLubyte g, GLubyte b, GLubyte a, GLfloat x, GLfloat y);
		 void glColor4ubVertex2fvSUN (GLubyte *c, GLfloat *v);
		 void glColor4ubVertex3fSUN(GLubyte r, GLubyte g, GLubyte b, GLubyte a, GLfloat x, GLfloat y, GLfloat z);
		 void glColor4ubVertex3fvSUN (GLubyte *c, GLfloat *v);
		 void glColor3fVertex3fSUN(GLfloat r, GLfloat g, GLfloat b, GLfloat x, GLfloat y, GLfloat z);
		 void glColor3fVertex3fvSUN (GLfloat *c, GLfloat *v);
		 void glNormal3fVertex3fSUN(GLfloat nx, GLfloat ny, GLfloat nz, GLfloat x, GLfloat y, GLfloat z);
		 void glNormal3fVertex3fvSUN (GLfloat *n, GLfloat *v);
		 void glColor4fNormal3fVertex3fSUN(GLfloat r, GLfloat g, GLfloat b, GLfloat a, GLfloat nx, GLfloat ny, GLfloat nz, GLfloat x, GLfloat y, GLfloat z);
		 void glColor4fNormal3fVertex3fvSUN (GLfloat *c, GLfloat *n, GLfloat *v);
		 void glTexCoord2fVertex3fSUN(GLfloat s, GLfloat t, GLfloat x, GLfloat y, GLfloat z);
		 void glTexCoord2fVertex3fvSUN (GLfloat *tc, GLfloat *v);
		 void glTexCoord4fVertex4fSUN(GLfloat s, GLfloat t, GLfloat p, GLfloat q, GLfloat x, GLfloat y, GLfloat z, GLfloat w);
		 void glTexCoord4fVertex4fvSUN (GLfloat *tc, GLfloat *v);
		 void glTexCoord2fColor4ubVertex3fSUN(GLfloat s, GLfloat t, GLubyte r, GLubyte g, GLubyte b, GLubyte a, GLfloat x, GLfloat y, GLfloat z);
		 void glTexCoord2fColor4ubVertex3fvSUN (GLfloat *tc, GLubyte *c, GLfloat *v);
		 void glTexCoord2fColor3fVertex3fSUN(GLfloat s, GLfloat t, GLfloat r, GLfloat g, GLfloat b, GLfloat x, GLfloat y, GLfloat z);
		 void glTexCoord2fColor3fVertex3fvSUN (GLfloat *tc, GLfloat *c, GLfloat *v);
		 void glTexCoord2fNormal3fVertex3fSUN(GLfloat s, GLfloat t, GLfloat nx, GLfloat ny, GLfloat nz, GLfloat x, GLfloat y, GLfloat z);
		 void glTexCoord2fNormal3fVertex3fvSUN (GLfloat *tc, GLfloat *n, GLfloat *v);
		 void glTexCoord2fColor4fNormal3fVertex3fSUN(GLfloat s, GLfloat t, GLfloat r, GLfloat g, GLfloat b, GLfloat a, GLfloat nx, GLfloat ny, GLfloat nz, GLfloat x, GLfloat y, GLfloat z);
		 void glTexCoord2fColor4fNormal3fVertex3fvSUN (GLfloat *tc, GLfloat *c, GLfloat *n, GLfloat *v);
		 void glTexCoord4fColor4fNormal3fVertex4fSUN(GLfloat s, GLfloat t, GLfloat p, GLfloat q, GLfloat r, GLfloat g, GLfloat b, GLfloat a, GLfloat nx, GLfloat ny, GLfloat nz, GLfloat x, GLfloat y, GLfloat z, GLfloat w);
		 void glTexCoord4fColor4fNormal3fVertex4fvSUN (GLfloat *tc, GLfloat *c, GLfloat *n, GLfloat *v);
		 void glReplacementCodeuiVertex3fSUN(GLuint rc, GLfloat x, GLfloat y, GLfloat z);
		 void glReplacementCodeuiVertex3fvSUN (GLuint *rc, GLfloat *v);
		 void glReplacementCodeuiColor4ubVertex3fSUN(GLuint rc, GLubyte r, GLubyte g, GLubyte b, GLubyte a, GLfloat x, GLfloat y, GLfloat z);
		 void glReplacementCodeuiColor4ubVertex3fvSUN (GLuint *rc, GLubyte *c, GLfloat *v);
		 void glReplacementCodeuiColor3fVertex3fSUN(GLuint rc, GLfloat r, GLfloat g, GLfloat b, GLfloat x, GLfloat y, GLfloat z);
		 void glReplacementCodeuiColor3fVertex3fvSUN (GLuint *rc, GLfloat *c, GLfloat *v);
		 void glReplacementCodeuiNormal3fVertex3fSUN(GLuint rc, GLfloat nx, GLfloat ny, GLfloat nz, GLfloat x, GLfloat y, GLfloat z);
		 void glReplacementCodeuiNormal3fVertex3fvSUN (GLuint *rc, GLfloat *n, GLfloat *v);
		 void glReplacementCodeuiColor4fNormal3fVertex3fSUN(GLuint rc, GLfloat r, GLfloat g, GLfloat b, GLfloat a, GLfloat nx, GLfloat ny, GLfloat nz, GLfloat x, GLfloat y, GLfloat z);
		 void glReplacementCodeuiColor4fNormal3fVertex3fvSUN (GLuint *rc, GLfloat *c, GLfloat *n, GLfloat *v);
		 void glReplacementCodeuiTexCoord2fVertex3fSUN(GLuint rc, GLfloat s, GLfloat t, GLfloat x, GLfloat y, GLfloat z);
		 void glReplacementCodeuiTexCoord2fVertex3fvSUN (GLuint *rc, GLfloat *tc, GLfloat *v);
		 void glReplacementCodeuiTexCoord2fNormal3fVertex3fSUN(GLuint rc, GLfloat s, GLfloat t, GLfloat nx, GLfloat ny, GLfloat nz, GLfloat x, GLfloat y, GLfloat z);
		 void glReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN (GLuint *rc, GLfloat *tc, GLfloat *n, GLfloat *v);
		 void glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fSUN(GLuint rc, GLfloat s, GLfloat t, GLfloat r, GLfloat g, GLfloat b, GLfloat a, GLfloat nx, GLfloat ny, GLfloat nz, GLfloat x, GLfloat y, GLfloat z);
		 void glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN (GLuint *rc, GLfloat *tc, GLfloat *c, GLfloat *n, GLfloat *v);
	}

	//GL_EXT_blend_func_separate
	version(GL_EXT_blend_func_separate)
	{
		 void glBlendFuncSeparateEXT(GLenum sfactorRGB, GLenum dfactorRGB, GLenum sfactorAlpha, GLenum dfactorAlpha);
	}

	//GL_INGR_color_clamp
	version(GL_INGR_color_clamp)
{}

	//GL_INGR_interlace_read
	version(GL_INGR_interlace_read)
	{}

	//GL_EXT_stencil_wrap
	version(GL_EXT_stencil_wrap)
	{}

	//GL_EXT_422_pixels
	version(GL_EXT_422_pixels)
	{}

	//GL_NV_texgen_reflection
	version(GL_NV_texgen_reflection)
	{}

	//GL_EXT_texture_cube_map
	version(GL_EXT_texture_cube_map)
	{}

	//GL_SUN_convolution_border_modes
	version(GL_SUN_convolution_border_modes)
	{}

	//GL_EXT_texture_env_add
	version(GL_EXT_texture_env_add)
	{}

	//GL_EXT_texture_lod_bias
	version(GL_EXT_texture_lod_bias)
	{}

	//GL_EXT_texture_filter_anisotropic
	version(GL_EXT_texture_filter_anisotropic)
	{}

	//GL_EXT_vertex_weighting
	version(GL_EXT_vertex_weighting)
	{
		 void glVertexWeightfEXT(GLfloat weight);
		 void glVertexWeightfvEXT (GLfloat *weight);
		 void glVertexWeightPointerEXT(GLsizei size, GLenum type, GLsizei stride, GLvoid *pointer);
	}

	//GL_NV_light_max_exponent
	version(GL_NV_light_max_exponent)
{}

	//GL_NV_vertex_array_range
	version(GL_NV_vertex_array_range)
	{
		 void glFlushVertexArrayRangeNV();
		 void glVertexArrayRangeNV(GLsizei length, GLvoid *pointer);
	}

	//GL_NV_register_combiners
	version(GL_NV_register_combiners)
	{
		 void glCombinerParameterfvNV(GLenum pname, GLfloat *params);
		 void glCombinerParameterfNV(GLenum pname, GLfloat param);
		 void glCombinerParameterivNV(GLenum pname, GLint *params);
		 void glCombinerParameteriNV(GLenum pname, GLint param);
		 void glCombinerInputNV(GLenum stage, GLenum portion, GLenum variable, GLenum input, GLenum mapping, GLenum componentUsage);
		 void glCombinerOutputNV(GLenum stage, GLenum portion, GLenum abOutput, GLenum cdOutput, GLenum sumOutput, GLenum scale, GLenum bias, GLboolean abDotProduct, GLboolean cdDotProduct, GLboolean muxSum);
		 void glFinalCombinerInputNV(GLenum variable, GLenum input, GLenum mapping, GLenum componentUsage);
		 void glGetCombinerInputParameterfvNV(GLenum stage, GLenum portion, GLenum variable, GLenum pname, GLfloat *params);
		 void glGetCombinerInputParameterivNV(GLenum stage, GLenum portion, GLenum variable, GLenum pname, GLint *params);
		 void glGetCombinerOutputParameterfvNV(GLenum stage, GLenum portion, GLenum pname, GLfloat *params);
		 void glGetCombinerOutputParameterivNV(GLenum stage, GLenum portion, GLenum pname, GLint *params);
		 void glGetFinalCombinerInputParameterfvNV(GLenum variable, GLenum pname, GLfloat *params);
		 void glGetFinalCombinerInputParameterivNV(GLenum variable, GLenum pname, GLint *params);
	}

	//GL_NV_fog_distance
	version(GL_NV_fog_distance)
{}

	//GL_NV_texgen_emboss
	version(GL_NV_texgen_emboss)
	{}

	//GL_NV_blend_square
	version(GL_NV_blend_square)
	{}

	//GL_NV_texture_env_combine4
	version(GL_NV_texture_env_combine4)
	{}

	//GL_MESA_resize_buffers
	version(GL_MESA_resize_buffers)
	{
		 void glResizeBuffersMESA();


	}

	//GL_MESA_window_pos
	version(GL_MESA_window_pos)
	{
		 void glWindowPos2dMESA(GLdouble x, GLdouble y);
		 void glWindowPos2dvMESA (GLdouble *v);
		 void glWindowPos2fMESA(GLfloat x, GLfloat y);
		 void glWindowPos2fvMESA (GLfloat *v);
		 void glWindowPos2iMESA(GLint x, GLint y);
		 void glWindowPos2ivMESA (GLint *v);
		 void glWindowPos2sMESA(GLshort x, GLshort y);
		 void glWindowPos2svMESA (GLshort *v);
		 void glWindowPos3dMESA(GLdouble x, GLdouble y, GLdouble z);
		 void glWindowPos3dvMESA (GLdouble *v);
		 void glWindowPos3fMESA(GLfloat x, GLfloat y, GLfloat z);
		 void glWindowPos3fvMESA (GLfloat *v);
		 void glWindowPos3iMESA(GLint x, GLint y, GLint z);
		 void glWindowPos3ivMESA (GLint *v);
		 void glWindowPos3sMESA(GLshort x, GLshort y, GLshort z);
		 void glWindowPos3svMESA (GLshort *v);
		 void glWindowPos4dMESA(GLdouble x, GLdouble y, GLdouble z, GLdouble w);
		 void glWindowPos4dvMESA (GLdouble *v);
		 void glWindowPos4fMESA(GLfloat x, GLfloat y, GLfloat z, GLfloat w);
		 void glWindowPos4fvMESA (GLfloat *v);
		 void glWindowPos4iMESA(GLint x, GLint y, GLint z, GLint w);
		 void glWindowPos4ivMESA (GLint *v);
		 void glWindowPos4sMESA(GLshort x, GLshort y, GLshort z, GLshort w);
		 void glWindowPos4svMESA (GLshort *v);
	}

	//GL_EXT_texture_compression_s3tc
	version(GL_EXT_texture_compression_s3tc)
{}

	//GL_IBM_cull_vertex
	version(GL_IBM_cull_vertex)
	{}

	//GL_IBM_multimode_draw_arrays
	version(GL_IBM_multimode_draw_arrays)
	{
		 void glMultiModeDrawArraysIBM (GLenum *mode, GLint *first, GLsizei *count, GLsizei primcount, GLint modestride);
		 void glMultiModeDrawElementsIBM (GLenum *mode, GLsizei *count, GLenum type, GLvoid* *indices, GLsizei primcount, GLint modestride);
	}

	//GL_IBM_vertex_array_lists
	version(GL_IBM_vertex_array_lists)
	{
		 void glColorPointerListIBM(GLint size, GLenum type, GLint stride, GLvoid* *pointer, GLint ptrstride);
		 void glSecondaryColorPointerListIBM(GLint size, GLenum type, GLint stride, GLvoid* *pointer, GLint ptrstride);
		 void glEdgeFlagPointerListIBM(GLint stride, GLboolean* *pointer, GLint ptrstride);
		 void glFogCoordPointerListIBM(GLenum type, GLint stride, GLvoid* *pointer, GLint ptrstride);
		 void glIndexPointerListIBM(GLenum type, GLint stride, GLvoid* *pointer, GLint ptrstride);
		 void glNormalPointerListIBM(GLenum type, GLint stride, GLvoid* *pointer, GLint ptrstride);
		 void glTexCoordPointerListIBM(GLint size, GLenum type, GLint stride, GLvoid* *pointer, GLint ptrstride);
		 void glVertexPointerListIBM(GLint size, GLenum type, GLint stride, GLvoid* *pointer, GLint ptrstride);
	}

	//GL_SGIX_subsample
	version(GL_SGIX_subsample)
{}

	//GL_SGIX_ycrcb_subsample
	version(GL_SGIX_ycrcb_subsample)
	{}

	//GL_SGIX_ycrcba
	version(GL_SGIX_ycrcba)
	{}

	//GL_SGI_depth_pass_instrument
	version(GL_SGI_depth_pass_instrument)
	{}

	//GL_3DFX_texture_compression_FXT1
	version(GL_3DFX_texture_compression_FXT1)
	{}

	//GL_3DFX_multisample
	version(GL_3DFX_multisample)
	{}

	//GL_3DFX_tbuffer
	version(GL_3DFX_tbuffer)
	{
		 void glTbufferMask3DFX(GLuint mask);
	}

	//GL_EXT_multisample
	version(GL_EXT_multisample)
	{
		 void glSampleMaskEXT(GLclampf value, GLboolean invert);
		 void glSamplePatternEXT(GLenum pattern);
	}

	//GL_SGIX_vertex_preclip
	version(GL_SGIX_vertex_preclip)
{}

	//GL_SGIX_convolution_accuracy
	version(GL_SGIX_convolution_accuracy)
	{}

	//GL_SGIX_resample
	version(GL_SGIX_resample)
	{}

	//GL_SGIS_point_line_texgen
	version(GL_SGIS_point_line_texgen)
	{}

	//GL_SGIS_texture_color_mask
	version(GL_SGIS_texture_color_mask)
	{
		 void glTextureColorMaskSGIS(GLboolean red, GLboolean green, GLboolean blue, GLboolean alpha);
	}

	//GL_EXT_texture_env_dot3
	version(GL_EXT_texture_env_dot3)
{}

	//GL_ATI_texture_mirror_once
	version(GL_ATI_texture_mirror_once)
	{}

	//GL_NV_fence
	version(GL_NV_fence)
	{
		 void glDeleteFencesNV(GLsizei n, GLuint *fences);
		 void glGenFencesNV(GLsizei n, GLuint *fences);
		 GLboolean glIsFenceNV(GLuint fence);
		 GLboolean glTestFenceNV(GLuint fence);
		 void glGetFenceivNV(GLuint fence, GLenum pname, GLint *params);
		 void glFinishFenceNV(GLuint fence);
		 void glSetFenceNV(GLuint fence, GLenum condition);
	}

	//GL_IBM_texture_mirrored_repeat
	version(GL_IBM_texture_mirrored_repeat)
{}

	//GL_NV_evaluators
	version(GL_NV_evaluators)
	{
		 void glMapControlPointsNV(GLenum target, GLuint index, GLenum type, GLsizei ustride, GLsizei vstride, GLint uorder, GLint vorder, GLboolean packed, GLvoid *points);
		 void glMapParameterivNV(GLenum target, GLenum pname, GLint *params);
		 void glMapParameterfvNV(GLenum target, GLenum pname, GLfloat *params);
		 void glGetMapControlPointsNV(GLenum target, GLuint index, GLenum type, GLsizei ustride, GLsizei vstride, GLboolean packed, GLvoid *points);
		 void glGetMapParameterivNV(GLenum target, GLenum pname, GLint *params);
		 void glGetMapParameterfvNV(GLenum target, GLenum pname, GLfloat *params);
		 void glGetMapAttribParameterivNV(GLenum target, GLuint index, GLenum pname, GLint *params);
		 void glGetMapAttribParameterfvNV(GLenum target, GLuint index, GLenum pname, GLfloat *params);
		 void glEvalMapsNV(GLenum target, GLenum mode);
	}

	//GL_NV_packed_depth_stencil
	version(GL_NV_packed_depth_stencil)
{}

	//GL_NV_register_combiners2
	version(GL_NV_register_combiners2)
	{
		 void glCombinerStageParameterfvNV(GLenum stage, GLenum pname, GLfloat *params);
		 void glGetCombinerStageParameterfvNV(GLenum stage, GLenum pname, GLfloat *params);
	}

	//GL_NV_texture_compression_vtc
	version(GL_NV_texture_compression_vtc)
{}

	//GL_NV_texture_rectangle
	version(GL_NV_texture_rectangle)
	{}

	//GL_NV_texture_shader
	version(GL_NV_texture_shader)
	{}

	//GL_NV_texture_shader2
	version(GL_NV_texture_shader2)
	{}

	//GL_NV_vertex_array_range2
	version(GL_NV_vertex_array_range2)
	{}

	//GL_NV_vertex_program
	version(GL_NV_vertex_program)
	{
		 GLboolean glAreProgramsResidentNV(GLsizei n, GLuint *programs, GLboolean *residences);
		 void glBindProgramNV(GLenum target, GLuint id);
		 void glDeleteProgramsNV(GLsizei n, GLuint *programs);
		 void glExecuteProgramNV(GLenum target, GLuint id, GLfloat *params);
		 void glGenProgramsNV(GLsizei n, GLuint *programs);
		 void glGetProgramParameterdvNV(GLenum target, GLuint index, GLenum pname, GLdouble *params);
		 void glGetProgramParameterfvNV(GLenum target, GLuint index, GLenum pname, GLfloat *params);
		 void glGetProgramivNV(GLuint id, GLenum pname, GLint *params);
		 void glGetProgramStringNV(GLuint id, GLenum pname, GLubyte *program);
		 void glGetTrackMatrixivNV(GLenum target, GLuint address, GLenum pname, GLint *params);
		 void glGetVertexAttribdvNV(GLuint index, GLenum pname, GLdouble *params);
		 void glGetVertexAttribfvNV(GLuint index, GLenum pname, GLfloat *params);
		 void glGetVertexAttribivNV(GLuint index, GLenum pname, GLint *params);
		 void glGetVertexAttribPointervNV(GLuint index, GLenum pname, GLvoid* *pointer);
		 GLboolean glIsProgramNV(GLuint id);
		 void glLoadProgramNV(GLenum target, GLuint id, GLsizei len, GLubyte *program);
		 void glProgramParameter4dNV(GLenum target, GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w);
		 void glProgramParameter4dvNV(GLenum target, GLuint index, GLdouble *v);
		 void glProgramParameter4fNV(GLenum target, GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w);
		 void glProgramParameter4fvNV(GLenum target, GLuint index, GLfloat *v);
		 void glProgramParameters4dvNV(GLenum target, GLuint index, GLuint count, GLdouble *v);
		 void glProgramParameters4fvNV(GLenum target, GLuint index, GLuint count, GLfloat *v);
		 void glRequestResidentProgramsNV(GLsizei n, GLuint *programs);
		 void glTrackMatrixNV(GLenum target, GLuint address, GLenum matrix, GLenum transform);
		 void glVertexAttribPointerNV(GLuint index, GLint fsize, GLenum type, GLsizei stride, GLvoid *pointer);
		 void glVertexAttrib1dNV(GLuint index, GLdouble x);
		 void glVertexAttrib1dvNV(GLuint index, GLdouble *v);
		 void glVertexAttrib1fNV(GLuint index, GLfloat x);
		 void glVertexAttrib1fvNV(GLuint index, GLfloat *v);
		 void glVertexAttrib1sNV(GLuint index, GLshort x);
		 void glVertexAttrib1svNV(GLuint index, GLshort *v);
		 void glVertexAttrib2dNV(GLuint index, GLdouble x, GLdouble y);
		 void glVertexAttrib2dvNV(GLuint index, GLdouble *v);
		 void glVertexAttrib2fNV(GLuint index, GLfloat x, GLfloat y);
		 void glVertexAttrib2fvNV(GLuint index, GLfloat *v);
		 void glVertexAttrib2sNV(GLuint index, GLshort x, GLshort y);
		 void glVertexAttrib2svNV(GLuint index, GLshort *v);
		 void glVertexAttrib3dNV(GLuint index, GLdouble x, GLdouble y, GLdouble z);
		 void glVertexAttrib3dvNV(GLuint index, GLdouble *v);
		 void glVertexAttrib3fNV(GLuint index, GLfloat x, GLfloat y, GLfloat z);
		 void glVertexAttrib3fvNV(GLuint index, GLfloat *v);
		 void glVertexAttrib3sNV(GLuint index, GLshort x, GLshort y, GLshort z);
		 void glVertexAttrib3svNV(GLuint index, GLshort *v);
		 void glVertexAttrib4dNV(GLuint index, GLdouble x, GLdouble y, GLdouble z, GLdouble w);
		 void glVertexAttrib4dvNV(GLuint index, GLdouble *v);
		 void glVertexAttrib4fNV(GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w);
		 void glVertexAttrib4fvNV(GLuint index, GLfloat *v);
		 void glVertexAttrib4sNV(GLuint index, GLshort x, GLshort y, GLshort z, GLshort w);
		 void glVertexAttrib4svNV(GLuint index, GLshort *v);
		 void glVertexAttrib4ubNV(GLuint index, GLubyte x, GLubyte y, GLubyte z, GLubyte w);
		 void glVertexAttrib4ubvNV(GLuint index, GLubyte *v);
		 void glVertexAttribs1dvNV(GLuint index, GLsizei count, GLdouble *v);
		 void glVertexAttribs1fvNV(GLuint index, GLsizei count, GLfloat *v);
		 void glVertexAttribs1svNV(GLuint index, GLsizei count, GLshort *v);
		 void glVertexAttribs2dvNV(GLuint index, GLsizei count, GLdouble *v);
		 void glVertexAttribs2fvNV(GLuint index, GLsizei count, GLfloat *v);
		 void glVertexAttribs2svNV(GLuint index, GLsizei count, GLshort *v);
		 void glVertexAttribs3dvNV(GLuint index, GLsizei count, GLdouble *v);
		 void glVertexAttribs3fvNV(GLuint index, GLsizei count, GLfloat *v);
		 void glVertexAttribs3svNV(GLuint index, GLsizei count, GLshort *v);
		 void glVertexAttribs4dvNV(GLuint index, GLsizei count, GLdouble *v);
		 void glVertexAttribs4fvNV(GLuint index, GLsizei count, GLfloat *v);
		 void glVertexAttribs4svNV(GLuint index, GLsizei count, GLshort *v);
		 void glVertexAttribs4ubvNV(GLuint index, GLsizei count, GLubyte *v);
	}

	//GL_SGIX_texture_coordinate_clamp
	version(GL_SGIX_texture_coordinate_clamp)
{}

	//GL_SGIX_scalebias_hint
	version(GL_SGIX_scalebias_hint)
	{}

	//GL_OML_interlace
	version(GL_OML_interlace)
	{}

	//GL_OML_subsample
	version(GL_OML_subsample)
	{}

	//GL_OML_resample
	version(GL_OML_resample)
	{}

	//GL_NV_copy_depth_to_color
	version(GL_NV_copy_depth_to_color)
	{}

	//GL_ATI_envmap_bumpmap
	version(GL_ATI_envmap_bumpmap)
	{
		 void glTexBumpParameterivATI(GLenum pname, GLint *param);
		 void glTexBumpParameterfvATI(GLenum pname, GLfloat *param);
		 void glGetTexBumpParameterivATI(GLenum pname, GLint *param);
		 void glGetTexBumpParameterfvATI(GLenum pname, GLfloat *param);
	}

	//GL_ATI_fragment_shader
	version(GL_ATI_fragment_shader)
	{
		 GLuint glGenFragmentShadersATI(GLuint range);
		 void glBindFragmentShaderATI(GLuint id);
		 void glDeleteFragmentShaderATI(GLuint id);
		 void glBeginFragmentShaderATI();
		 void glEndFragmentShaderATI();
		 void glPassTexCoordATI(GLuint dst, GLuint coord, GLenum swizzle);
		 void glSampleMapATI(GLuint dst, GLuint interp, GLenum swizzle);
		 void glColorFragmentOp1ATI(GLenum op, GLuint dst, GLuint dstMask, GLuint dstMod, GLuint arg1, GLuint arg1Rep, GLuint arg1Mod);
		 void glColorFragmentOp2ATI(GLenum op, GLuint dst, GLuint dstMask, GLuint dstMod, GLuint arg1, GLuint arg1Rep, GLuint arg1Mod, GLuint arg2, GLuint arg2Rep, GLuint arg2Mod);
		 void glColorFragmentOp3ATI(GLenum op, GLuint dst, GLuint dstMask, GLuint dstMod, GLuint arg1, GLuint arg1Rep, GLuint arg1Mod, GLuint arg2, GLuint arg2Rep, GLuint arg2Mod, GLuint arg3, GLuint arg3Rep, GLuint arg3Mod);
		 void glAlphaFragmentOp1ATI(GLenum op, GLuint dst, GLuint dstMod, GLuint arg1, GLuint arg1Rep, GLuint arg1Mod);
		 void glAlphaFragmentOp2ATI(GLenum op, GLuint dst, GLuint dstMod, GLuint arg1, GLuint arg1Rep, GLuint arg1Mod, GLuint arg2, GLuint arg2Rep, GLuint arg2Mod);
		 void glAlphaFragmentOp3ATI(GLenum op, GLuint dst, GLuint dstMod, GLuint arg1, GLuint arg1Rep, GLuint arg1Mod, GLuint arg2, GLuint arg2Rep, GLuint arg2Mod, GLuint arg3, GLuint arg3Rep, GLuint arg3Mod);
		 void glSetFragmentShaderConstantATI(GLuint dst, GLfloat *value);
	}

	//GL_ATI_pn_triangles
	version(GL_ATI_pn_triangles)
	{
		 void glPNTrianglesiATI(GLenum pname, GLint param);
		 void glPNTrianglesfATI(GLenum pname, GLfloat param);
	}

	//GL_ATI_vertex_array_object
	version(GL_ATI_vertex_array_object)
	{
		 GLuint glNewObjectBufferATI(GLsizei size, GLvoid *pointer, GLenum usage);
		 GLboolean glIsObjectBufferATI(GLuint buffer);
		 void glUpdateObjectBufferATI(GLuint buffer, GLuint offset, GLsizei size, GLvoid *pointer, GLenum preserve);
		 void glGetObjectBufferfvATI(GLuint buffer, GLenum pname, GLfloat *params);
		 void glGetObjectBufferivATI(GLuint buffer, GLenum pname, GLint *params);
		 void glFreeObjectBufferATI(GLuint buffer);
		 void glArrayObjectATI(GLenum array, GLint size, GLenum type, GLsizei stride, GLuint buffer, GLuint offset);
		 void glGetArrayObjectfvATI(GLenum array, GLenum pname, GLfloat *params);
		 void glGetArrayObjectivATI(GLenum array, GLenum pname, GLint *params);
		 void glVariantArrayObjectATI(GLuint id, GLenum type, GLsizei stride, GLuint buffer, GLuint offset);
		 void glGetVariantArrayObjectfvATI(GLuint id, GLenum pname, GLfloat *params);
		 void glGetVariantArrayObjectivATI(GLuint id, GLenum pname, GLint *params);
	}

	//GL_EXT_vertex_shader
	version(GL_EXT_vertex_shader)
	{
		 void glBeginVertexShaderEXT();
		 void glEndVertexShaderEXT();
		 void glBindVertexShaderEXT(GLuint id);
		 GLuint glGenVertexShadersEXT(GLuint range);
		 void glDeleteVertexShaderEXT(GLuint id);
		 void glShaderOp1EXT(GLenum op, GLuint res, GLuint arg1);
		 void glShaderOp2EXT(GLenum op, GLuint res, GLuint arg1, GLuint arg2);
		 void glShaderOp3EXT(GLenum op, GLuint res, GLuint arg1, GLuint arg2, GLuint arg3);
		 void glSwizzleEXT(GLuint res, GLuint inn, GLenum outX, GLenum outY, GLenum outZ, GLenum outW);
		 void glWriteMaskEXT(GLuint res, GLuint inn, GLenum outX, GLenum outY, GLenum outZ, GLenum outW);
		 void glInsertComponentEXT(GLuint res, GLuint src, GLuint num);
		 void glExtractComponentEXT(GLuint res, GLuint src, GLuint num);
		 GLuint glGenSymbolsEXT(GLenum datatype, GLenum storagetype, GLenum range, GLuint components);
		 void glSetInvariantEXT(GLuint id, GLenum type, GLvoid *addr);
		 void glSetLocalConstantEXT(GLuint id, GLenum type, GLvoid *addr);
		 void glVariantbvEXT(GLuint id, GLbyte *addr);
		 void glVariantsvEXT(GLuint id, GLshort *addr);
		 void glVariantivEXT(GLuint id, GLint *addr);
		 void glVariantfvEXT(GLuint id, GLfloat *addr);
		 void glVariantdvEXT(GLuint id, GLdouble *addr);
		 void glVariantubvEXT(GLuint id, GLubyte *addr);
		 void glVariantusvEXT(GLuint id, GLushort *addr);
		 void glVariantuivEXT(GLuint id, GLuint *addr);
		 void glVariantPointerEXT(GLuint id, GLenum type, GLuint stride, GLvoid *addr);
		 void glEnableVariantClientStateEXT(GLuint id);
		 void glDisableVariantClientStateEXT(GLuint id);
		 GLuint glBindLightParameterEXT(GLenum light, GLenum value);
		 GLuint glBindMaterialParameterEXT(GLenum face, GLenum value);
		 GLuint glBindTexGenParameterEXT(GLenum unit, GLenum coord, GLenum value);
		 GLuint glBindTextureUnitParameterEXT(GLenum unit, GLenum value);
		 GLuint glBindParameterEXT(GLenum value);
		 GLboolean glIsVariantEnabledEXT(GLuint id, GLenum cap);
		 void glGetVariantBooleanvEXT(GLuint id, GLenum value, GLboolean *data);
		 void glGetVariantIntegervEXT(GLuint id, GLenum value, GLint *data);
		 void glGetVariantFloatvEXT(GLuint id, GLenum value, GLfloat *data);
		 void glGetVariantPointervEXT(GLuint id, GLenum value, GLvoid* *data);
		 void glGetInvariantBooleanvEXT(GLuint id, GLenum value, GLboolean *data);
		 void glGetInvariantIntegervEXT(GLuint id, GLenum value, GLint *data);
		 void glGetInvariantFloatvEXT(GLuint id, GLenum value, GLfloat *data);
		 void glGetLocalConstantBooleanvEXT(GLuint id, GLenum value, GLboolean *data);
		 void glGetLocalConstantIntegervEXT(GLuint id, GLenum value, GLint *data);
		 void glGetLocalConstantFloatvEXT(GLuint id, GLenum value, GLfloat *data);
	}

	//GL_ATI_vertex_streams
	version(GL_ATI_vertex_streams)
	{
		 void glVertexStream1sATI(GLenum stream, GLshort x);
		 void glVertexStream1svATI(GLenum stream, GLshort *coords);
		 void glVertexStream1iATI(GLenum stream, GLint x);
		 void glVertexStream1ivATI(GLenum stream, GLint *coords);
		 void glVertexStream1fATI(GLenum stream, GLfloat x);
		 void glVertexStream1fvATI(GLenum stream, GLfloat *coords);
		 void glVertexStream1dATI(GLenum stream, GLdouble x);
		 void glVertexStream1dvATI(GLenum stream, GLdouble *coords);
		 void glVertexStream2sATI(GLenum stream, GLshort x, GLshort y);
		 void glVertexStream2svATI(GLenum stream, GLshort *coords);
		 void glVertexStream2iATI(GLenum stream, GLint x, GLint y);
		 void glVertexStream2ivATI(GLenum stream, GLint *coords);
		 void glVertexStream2fATI(GLenum stream, GLfloat x, GLfloat y);
		 void glVertexStream2fvATI(GLenum stream, GLfloat *coords);
		 void glVertexStream2dATI(GLenum stream, GLdouble x, GLdouble y);
		 void glVertexStream2dvATI(GLenum stream, GLdouble *coords);
		 void glVertexStream3sATI(GLenum stream, GLshort x, GLshort y, GLshort z);
		 void glVertexStream3svATI(GLenum stream, GLshort *coords);
		 void glVertexStream3iATI(GLenum stream, GLint x, GLint y, GLint z);
		 void glVertexStream3ivATI(GLenum stream, GLint *coords);
		 void glVertexStream3fATI(GLenum stream, GLfloat x, GLfloat y, GLfloat z);
		 void glVertexStream3fvATI(GLenum stream, GLfloat *coords);
		 void glVertexStream3dATI(GLenum stream, GLdouble x, GLdouble y, GLdouble z);
		 void glVertexStream3dvATI(GLenum stream, GLdouble *coords);
		 void glVertexStream4sATI(GLenum stream, GLshort x, GLshort y, GLshort z, GLshort w);
		 void glVertexStream4svATI(GLenum stream, GLshort *coords);
		 void glVertexStream4iATI(GLenum stream, GLint x, GLint y, GLint z, GLint w);
		 void glVertexStream4ivATI(GLenum stream, GLint *coords);
		 void glVertexStream4fATI(GLenum stream, GLfloat x, GLfloat y, GLfloat z, GLfloat w);
		 void glVertexStream4fvATI(GLenum stream, GLfloat *coords);
		 void glVertexStream4dATI(GLenum stream, GLdouble x, GLdouble y, GLdouble z, GLdouble w);
		 void glVertexStream4dvATI(GLenum stream, GLdouble *coords);
		 void glNormalStream3bATI(GLenum stream, GLbyte nx, GLbyte ny, GLbyte nz);
		 void glNormalStream3bvATI(GLenum stream, GLbyte *coords);
		 void glNormalStream3sATI(GLenum stream, GLshort nx, GLshort ny, GLshort nz);
		 void glNormalStream3svATI(GLenum stream, GLshort *coords);
		 void glNormalStream3iATI(GLenum stream, GLint nx, GLint ny, GLint nz);
		 void glNormalStream3ivATI(GLenum stream, GLint *coords);
		 void glNormalStream3fATI(GLenum stream, GLfloat nx, GLfloat ny, GLfloat nz);
		 void glNormalStream3fvATI(GLenum stream, GLfloat *coords);
		 void glNormalStream3dATI(GLenum stream, GLdouble nx, GLdouble ny, GLdouble nz);
		 void glNormalStream3dvATI(GLenum stream, GLdouble *coords);
		 void glClientActiveVertexStreamATI(GLenum stream);
		 void glVertexBlendEnviATI(GLenum pname, GLint param);
		 void glVertexBlendEnvfATI(GLenum pname, GLfloat param);
	}

	//GL_ATI_element_array
	version(GL_ATI_element_array)
	{
		 void glElementPointerATI(GLenum type, GLvoid *pointer);
		 void glDrawElementArrayATI(GLenum mode, GLsizei count);
		 void glDrawRangeElementArrayATI(GLenum mode, GLuint start, GLuint end, GLsizei count);
	}

	//GL_SUN_mesh_array
	version(GL_SUN_mesh_array)
	{
		 void glDrawMeshArraysSUN(GLenum mode, GLint first, GLsizei count, GLsizei width);
	}

	//GL_SUN_slice_accum
	version(GL_SUN_slice_accum)
{}

	//GL_NV_multisample_filter_hint
	version(GL_NV_multisample_filter_hint)
	{}

	//GL_NV_depth_clamp
	version(GL_NV_depth_clamp)
	{}

	//GL_NV_occlusion_query
	version(GL_NV_occlusion_query)
	{
		 void glGenOcclusionQueriesNV(GLsizei n, GLuint *ids);
		 void glDeleteOcclusionQueriesNV(GLsizei n, GLuint *ids);
		 GLboolean glIsOcclusionQueryNV(GLuint id);
		 void glBeginOcclusionQueryNV(GLuint id);
		 void glGetOcclusionQueryivNV(GLuint id, GLenum pname, GLint *params);
		 void glGetOcclusionQueryuivNV(GLuint id, GLenum pname, GLuint *params);
		 void glEndOcclusionQueryNV();
	}

	//GL_NV_point_sprite
	version(GL_NV_point_sprite)
	{
		 void glPointParameteriNV(GLenum pname, GLint param);
		 void glPointParameterivNV(GLenum pname, GLint *params);
	}

	//GL_NV_texture_shader3
	version(GL_NV_texture_shader3)
{}

	//GL_NV_vertex_program1_1
	version(GL_NV_vertex_program1_1)
	{}

	//GL_EXT_shadow_funcs
	version(GL_EXT_shadow_funcs)
	{}

	//GL_EXT_stencil_two_side
	version(GL_EXT_stencil_two_side)
	{
		 void glActiveStencilFaceEXT(GLenum face);
	}

	//GL_ATI_text_fragment_shader
	version(GL_ATI_text_fragment_shader)
{}

	//GL_APPLE_client_storage
	version(GL_APPLE_client_storage)
	{}

	//GL_APPLE_element_array
	version(GL_APPLE_element_array)
	{
		 void glElementPointerAPPLE(GLenum type, GLvoid *pointer);
		 void glDrawElementArrayAPPLE(GLenum mode, GLint first, GLsizei count);
		 void glDrawRangeElementArrayAPPLE(GLenum mode, GLuint start, GLuint end, GLint first, GLsizei count);
		 void glMultiDrawElementArrayAPPLE(GLenum mode, GLint *first, GLsizei *count, GLsizei primcount);
		 void glMultiDrawRangeElementArrayAPPLE(GLenum mode, GLuint start, GLuint end, GLint *first, GLsizei *count, GLsizei primcount);
	}

	//GL_APPLE_fence
	version(GL_APPLE_fence)
	{
		 void glGenFencesAPPLE(GLsizei n, GLuint *fences);
		 void glDeleteFencesAPPLE(GLsizei n, GLuint *fences);
		 void glSetFenceAPPLE(GLuint fence);
		 GLboolean glIsFenceAPPLE(GLuint fence);
		 GLboolean glTestFenceAPPLE(GLuint fence);
		 void glFinishFenceAPPLE(GLuint fence);
		 GLboolean glTestObjectAPPLE(GLenum object, GLuint name);
		 void glFinishObjectAPPLE(GLenum object, GLint name);
	}

	//GL_APPLE_vertex_array_object
	version(GL_APPLE_vertex_array_object)
	{
		 void glBindVertexArrayAPPLE(GLuint array);
		 void glDeleteVertexArraysAPPLE(GLsizei n, GLuint *arrays);
		 void glGenVertexArraysAPPLE(GLsizei n, GLuint *arrays);
		 GLboolean glIsVertexArrayAPPLE(GLuint array);
	}

	//GL_APPLE_vertex_array_range
	version(GL_APPLE_vertex_array_range)
	{
		 void glVertexArrayRangeAPPLE(GLsizei length, GLvoid *pointer);
		 void glFlushVertexArrayRangeAPPLE(GLsizei length, GLvoid *pointer);
		 void glVertexArrayParameteriAPPLE(GLenum pname, GLint param);
	}

	//GL_APPLE_ycbcr_422
	version(GL_APPLE_ycbcr_422)
{}

	//GL_S3_s3tc
	version(GL_S3_s3tc)
	{}

	//GL_ATI_draw_buffers
	version(GL_ATI_draw_buffers)
	{
		 void glDrawBuffersATI(GLsizei n, GLenum *bufs);
	}

	//GL_ATI_texture_env_combine3
	version(GL_ATI_texture_env_combine3)
{}

	//GL_ATI_texture_float
	version(GL_ATI_texture_float)
	{}

	//GL_NV_float_buffer
	version(GL_NV_float_buffer)
	{}

	//GL_NV_fragment_program
	version(GL_NV_fragment_program)
	{
		 void glProgramNamedParameter4fNV(GLuint id, GLsizei len, GLubyte *name, GLfloat x, GLfloat y, GLfloat z, GLfloat w);
		 void glProgramNamedParameter4dNV(GLuint id, GLsizei len, GLubyte *name, GLdouble x, GLdouble y, GLdouble z, GLdouble w);
		 void glProgramNamedParameter4fvNV(GLuint id, GLsizei len, GLubyte *name, GLfloat *v);
		 void glProgramNamedParameter4dvNV(GLuint id, GLsizei len, GLubyte *name, GLdouble *v);
		 void glGetProgramNamedParameterfvNV(GLuint id, GLsizei len, GLubyte *name, GLfloat *params);
		 void glGetProgramNamedParameterdvNV(GLuint id, GLsizei len, GLubyte *name, GLdouble *params);
	}

	//GL_NV_half_float
	version(GL_NV_half_float)
	{
		 void glVertex2hNV(GLhalfNV x, GLhalfNV y);
		 void glVertex2hvNV (GLhalfNV *v);
		 void glVertex3hNV(GLhalfNV x, GLhalfNV y, GLhalfNV z);
		 void glVertex3hvNV (GLhalfNV *v);
		 void glVertex4hNV(GLhalfNV x, GLhalfNV y, GLhalfNV z, GLhalfNV w);
		 void glVertex4hvNV (GLhalfNV *v);
		 void glNormal3hNV(GLhalfNV nx, GLhalfNV ny, GLhalfNV nz);
		 void glNormal3hvNV (GLhalfNV *v);
		 void glColor3hNV(GLhalfNV red, GLhalfNV green, GLhalfNV blue);
		 void glColor3hvNV (GLhalfNV *v);
		 void glColor4hNV(GLhalfNV red, GLhalfNV green, GLhalfNV blue, GLhalfNV alpha);
		 void glColor4hvNV (GLhalfNV *v);
		 void glTexCoord1hNV(GLhalfNV s);
		 void glTexCoord1hvNV (GLhalfNV *v);
		 void glTexCoord2hNV(GLhalfNV s, GLhalfNV t);
		 void glTexCoord2hvNV (GLhalfNV *v);
		 void glTexCoord3hNV(GLhalfNV s, GLhalfNV t, GLhalfNV r);
		 void glTexCoord3hvNV (GLhalfNV *v);
		 void glTexCoord4hNV(GLhalfNV s, GLhalfNV t, GLhalfNV r, GLhalfNV q);
		 void glTexCoord4hvNV (GLhalfNV *v);
		 void glMultiTexCoord1hNV(GLenum target, GLhalfNV s);
		 void glMultiTexCoord1hvNV(GLenum target, GLhalfNV *v);
		 void glMultiTexCoord2hNV(GLenum target, GLhalfNV s, GLhalfNV t);
		 void glMultiTexCoord2hvNV(GLenum target, GLhalfNV *v);
		 void glMultiTexCoord3hNV(GLenum target, GLhalfNV s, GLhalfNV t, GLhalfNV r);
		 void glMultiTexCoord3hvNV(GLenum target, GLhalfNV *v);
		 void glMultiTexCoord4hNV(GLenum target, GLhalfNV s, GLhalfNV t, GLhalfNV r, GLhalfNV q);
		 void glMultiTexCoord4hvNV(GLenum target, GLhalfNV *v);
		 void glFogCoordhNV(GLhalfNV fog);
		 void glFogCoordhvNV (GLhalfNV *fog);
		 void glSecondaryColor3hNV(GLhalfNV red, GLhalfNV green, GLhalfNV blue);
		 void glSecondaryColor3hvNV (GLhalfNV *v);
		 void glVertexWeighthNV(GLhalfNV weight);
		 void glVertexWeighthvNV (GLhalfNV *weight);
		 void glVertexAttrib1hNV(GLuint index, GLhalfNV x);
		 void glVertexAttrib1hvNV(GLuint index, GLhalfNV *v);
		 void glVertexAttrib2hNV(GLuint index, GLhalfNV x, GLhalfNV y);
		 void glVertexAttrib2hvNV(GLuint index, GLhalfNV *v);
		 void glVertexAttrib3hNV(GLuint index, GLhalfNV x, GLhalfNV y, GLhalfNV z);
		 void glVertexAttrib3hvNV(GLuint index, GLhalfNV *v);
		 void glVertexAttrib4hNV(GLuint index, GLhalfNV x, GLhalfNV y, GLhalfNV z, GLhalfNV w);
		 void glVertexAttrib4hvNV(GLuint index, GLhalfNV *v);
		 void glVertexAttribs1hvNV(GLuint index, GLsizei n, GLhalfNV *v);
		 void glVertexAttribs2hvNV(GLuint index, GLsizei n, GLhalfNV *v);
		 void glVertexAttribs3hvNV(GLuint index, GLsizei n, GLhalfNV *v);
		 void glVertexAttribs4hvNV(GLuint index, GLsizei n, GLhalfNV *v);
	}

	//GL_NV_pixel_data_range
	version(GL_NV_pixel_data_range)
	{
		 void glPixelDataRangeNV(GLenum target, GLsizei length, GLvoid *pointer);
		 void glFlushPixelDataRangeNV(GLenum target);
	}

	//GL_NV_primitive_restart
	version(GL_NV_primitive_restart)
	{
		 void glPrimitiveRestartIndexNV(GLuint index);
		 void glPrimitiveRestartNV();
	}

	//GL_NV_texture_expand_normal
	version(GL_NV_texture_expand_normal)
{}

	//GL_NV_vertex_program2
	version(GL_NV_vertex_program2)
	{}

	//GL_ATI_map_object_buffer
	version(GL_ATI_map_object_buffer)
	{
		 GLvoid* glMapObjectBufferATI(GLuint buffer);
		 void glUnmapObjectBufferATI(GLuint buffer);
	}

	//GL_ATI_separate_stencil
	version(GL_ATI_separate_stencil)
	{
		 void glStencilOpSeparateATI(GLenum face, GLenum sfail, GLenum dpfail, GLenum dppass);
		 void glStencilFuncSeparateATI(GLenum frontfunc, GLenum backfunc, GLint r, GLuint mask);
	}

	//GL_ATI_vertex_attrib_array_object
	version(GL_ATI_vertex_attrib_array_object)
	{
		 void glVertexAttribArrayObjectATI(GLuint index, GLint size, GLenum type, GLboolean normalized, GLsizei stride, GLuint buffer, GLuint offset);
		 void glGetVertexAttribArrayObjectfvATI(GLuint index, GLenum pname, GLfloat *params);
		 void glGetVertexAttribArrayObjectivATI(GLuint index, GLenum pname, GLint *params);
	}

	//GL_EXT_depth_bounds_test
	version(GL_EXT_depth_bounds_test)
	{
		 void glDepthBoundsEXT(GLclampd zmin, GLclampd zmax);
	}

	//GL_EXT_texture_mirror_clamp
	version(GL_EXT_texture_mirror_clamp)
{}

	//GL_EXT_blend_equation_separate
	version(GL_EXT_blend_equation_separate)
	{
		 void glBlendEquationSeparateEXT(GLenum modeRGB, GLenum modeAlpha);
	}

	//GL_MESA_pack_invert
	version(GL_MESA_pack_invert)
{}

	//GL_MESA_ycbcr_texture
	version(GL_MESA_ycbcr_texture)
	{}

	//GL_EXT_color_matrix
	version(GL_EXT_color_matrix)
	{}

	//GL_SGIS_texture_border_clamp
	version(GL_SGIS_texture_border_clamp)
	{}

	//GL_SGIX_texture_select
	version(GL_SGIX_texture_select)
	{}

	//GL_INGR_blend_func_separate
	version(GL_INGR_blend_func_separate)
	{
		 void glBlendFuncSeparateINGR(GLenum sfactorRGB, GLenum dfactorRGB, GLenum sfactorAlpha, GLenum dfactorAlpha);
	}

	//GL_SGIX_depth_pass_instrument
	version(GL_SGIX_depth_pass_instrument)
{}

	//GL_SGIX_igloo_interface
	version(GL_SGIX_igloo_interface)
	{
		 void glIglooInterfaceSGIX(GLenum pname, GLvoid *params);
	}

	//WIN32 SPECIFIC
	version(Windows)
	{
		// Extension querying variables
		//WGL_ARB_buffer_region
		version(WGL_ARB_buffer_region)
		{
			 HANDLE  wglCreateBufferRegionARB(HDC hDC, int iLayerPlane, UINT uType);
			 VOID  wglDeleteBufferRegionARB(HANDLE hRegion);
			 BOOL  wglSaveBufferRegionARB(HANDLE hRegion, int x, int y, int width, int height);
			 BOOL  wglRestoreBufferRegionARB(HANDLE hRegion, int x, int y, int width, int height, int xSrc, int ySrc);
		}

		//WGL_ARB_multisample
		version(WGL_ARB_multisample)
	{}

		//WGL_ARB_extensions_string
		version(WGL_ARB_extensions_string)
		{
			 char *  wglGetExtensionsStringARB(HDC hdc);
		}

		//WGL_ARB_pixel_format
		version(WGL_ARB_pixel_format)
		{
			 BOOL  wglGetPixelFormatAttribivARB(HDC hdc, int iPixelFormat, int iLayerPlane, UINT nAttributes, int *piAttributes, int *piValues);
			 BOOL  wglGetPixelFormatAttribfvARB(HDC hdc, int iPixelFormat, int iLayerPlane, UINT nAttributes, int *piAttributes, FLOAT *pfValues);
			 BOOL  wglChoosePixelFormatARB(HDC hdc, int *piAttribIList, FLOAT *pfAttribFList, UINT nMaxFormats, int *piFormats, UINT *nNumFormats);
		}

		//WGL_ARB_make_current_read
		version(WGL_ARB_make_current_read)
		{
			 BOOL  wglMakeContextCurrentARB(HDC hDrawDC, HDC hReadDC, HGLRC hglrc);
			 HDC wglGetCurrentReadDCARB();
		}

		//WGL_ARB_pbuffer
		version(WGL_ARB_pbuffer)
		{
			 HPBUFFERARB  wglCreatePbufferARB(HDC hDC, int iPixelFormat, int iWidth, int iHeight, int *piAttribList);
			 HDC  wglGetPbufferDCARB(HPBUFFERARB hPbuffer);
			 int  wglReleasePbufferDCARB(HPBUFFERARB hPbuffer, HDC hDC);
			 BOOL  wglDestroyPbufferARB(HPBUFFERARB hPbuffer);
			 BOOL  wglQueryPbufferARB(HPBUFFERARB hPbuffer, int iAttribute, int *piValue);
		}

		//WGL_ARB_render_texture
		version(WGL_ARB_render_texture)
		{
			 BOOL  wglBindTexImageARB(HPBUFFERARB hPbuffer, int iBuffer);
			 BOOL  wglReleaseTexImageARB(HPBUFFERARB hPbuffer, int iBuffer);
			 BOOL  wglSetPbufferAttribARB(HPBUFFERARB hPbuffer, int *piAttribList);
		}

		//WGL_EXT_make_current_read
		version(WGL_EXT_make_current_read)
		{
			 BOOL  wglMakeContextCurrentEXT(HDC hDrawDC, HDC hReadDC, HGLRC hglrc);
			 HDC wglGetCurrentReadDCEXT();
		}

		//WGL_EXT_pixel_format
		version(WGL_EXT_pixel_format)
		{
			 BOOL  wglGetPixelFormatAttribivEXT(HDC hdc, int iPixelFormat, int iLayerPlane, UINT nAttributes, int *piAttributes, int *piValues);
			 BOOL  wglGetPixelFormatAttribfvEXT(HDC hdc, int iPixelFormat, int iLayerPlane, UINT nAttributes, int *piAttributes, FLOAT *pfValues);
			 BOOL  wglChoosePixelFormatEXT(HDC hdc, int *piAttribIList, FLOAT *pfAttribFList, UINT nMaxFormats, int *piFormats, UINT *nNumFormats);
		}

		//WGL_EXT_pbuffer
		version(WGL_EXT_pbuffer)
		{
			 HPBUFFEREXT  wglCreatePbufferEXT(HDC hDC, int iPixelFormat, int iWidth, int iHeight, int *piAttribList);
			 HDC  wglGetPbufferDCEXT(HPBUFFEREXT hPbuffer);
			 int  wglReleasePbufferDCEXT(HPBUFFEREXT hPbuffer, HDC hDC);
			 BOOL  wglDestroyPbufferEXT(HPBUFFEREXT hPbuffer);
			 BOOL  wglQueryPbufferEXT(HPBUFFEREXT hPbuffer, int iAttribute, int *piValue);
		}

		//WGL_EXT_depth_float
		version(WGL_EXT_depth_float)
	{}

		//WGL_3DFX_multisample
		version(WGL_3DFX_multisample)
		{}

		//WGL_EXT_multisample
		version(WGL_EXT_multisample)
		{}

		//WGL_I3D_digital_video_control
		version(WGL_I3D_digital_video_control)
		{
			 BOOL  wglGetDigitalVideoParametersI3D(HDC hDC, int iAttribute, int *piValue);
			 BOOL  wglSetDigitalVideoParametersI3D(HDC hDC, int iAttribute, int *piValue);
		}

		//WGL_I3D_gamma
		version(WGL_I3D_gamma)
		{
			 BOOL  wglGetGammaTableParametersI3D(HDC hDC, int iAttribute, int *piValue);
			 BOOL  wglSetGammaTableParametersI3D(HDC hDC, int iAttribute, int *piValue);
			 BOOL  wglGetGammaTableI3D(HDC hDC, int iEntries, USHORT *puRed, USHORT *puGreen, USHORT *puBlue);
			 BOOL  wglSetGammaTableI3D(HDC hDC, int iEntries, USHORT *puRed, USHORT *puGreen, USHORT *puBlue);
		}

		//WGL_I3D_genlock
		version(WGL_I3D_genlock)
		{
			 BOOL  wglEnableGenlockI3D(HDC hDC);
			 BOOL  wglDisableGenlockI3D(HDC hDC);
			 BOOL  wglIsEnabledGenlockI3D(HDC hDC, BOOL *pFlag);
			 BOOL  wglGenlockSourceI3D(HDC hDC, UINT uSource);
			 BOOL  wglGetGenlockSourceI3D(HDC hDC, UINT *uSource);
			 BOOL  wglGenlockSourceEdgeI3D(HDC hDC, UINT uEdge);
			 BOOL  wglGetGenlockSourceEdgeI3D(HDC hDC, UINT *uEdge);
			 BOOL  wglGenlockSampleRateI3D(HDC hDC, UINT uRate);
			 BOOL  wglGetGenlockSampleRateI3D(HDC hDC, UINT *uRate);
			 BOOL  wglGenlockSourceDelayI3D(HDC hDC, UINT uDelay);
			 BOOL  wglGetGenlockSourceDelayI3D(HDC hDC, UINT *uDelay);
			 BOOL  wglQueryGenlockMaxSourceDelayI3D(HDC hDC, UINT *uMaxLineDelay, UINT *uMaxPixelDelay);
		}

		//WGL_I3D_image_buffer
		version(WGL_I3D_image_buffer)
		{
			 LPVOID  wglCreateImageBufferI3D(HDC hDC, DWORD dwSize, UINT uFlags);
			 BOOL  wglDestroyImageBufferI3D(HDC hDC, LPVOID pAddress);
			 BOOL  wglAssociateImageBufferEventsI3D(HDC hDC, HANDLE *pEvent, LPVOID *pAddress, DWORD *pSize, UINT count);
			 BOOL  wglReleaseImageBufferEventsI3D(HDC hDC, LPVOID *pAddress, UINT count);
		}

		//WGL_I3D_swap_frame_lock
		version(WGL_I3D_swap_frame_lock)
		{
			 BOOL  wglIsEnabledFrameLockI3D(BOOL *pFlag);
			 BOOL  wglQueryFrameLockMasterI3D(BOOL *pFlag);
			 BOOL wglEnableFrameLockI3D();
			 BOOL wglDisableFrameLockI3D();
		}

		//WGL_NV_render_depth_texture
		version(WGL_NV_render_depth_texture)
	{}

		//WGL_NV_render_texture_rectangle
		version(WGL_NV_render_texture_rectangle)
		{}

		//WGL_NV_float_buffer
		version(WGL_NV_float_buffer)
		{}

		//WGL_EXT_display_color_table
		version(WGL_EXT_display_color_table)
		{
			 GLboolean  wglCreateDisplayColorTableEXT(GLushort id);
			 GLboolean  wglLoadDisplayColorTableEXT (GLushort *table, GLuint length);
			 GLboolean  wglBindDisplayColorTableEXT(GLushort id);
			 VOID  wglDestroyDisplayColorTableEXT(GLushort id);
		}

		//WGL_EXT_extensions_string
		version(WGL_EXT_extensions_string)
		{
			 char * wglGetExtensionsStringEXT();


		}

		//WGL_EXT_swap_control
		version(WGL_EXT_swap_control)
		{
			 BOOL  wglSwapIntervalEXT(int interval);
			 int wglGetSwapIntervalEXT();
		}

		//WGL_NV_vertex_array_range
		version(WGL_NV_vertex_array_range)
		{
			 void*  wglAllocateMemoryNV(GLsizei size, GLfloat readfreq, GLfloat writefreq, GLfloat priority);
			 void  wglFreeMemoryNV(void *pointer);
		}

		//WGL_OML_sync_control
		version(WGL_OML_sync_control)
		{
			 BOOL  wglGetSyncValuesOML(HDC hdc, INT64 *ust, INT64 *msc, INT64 *sbc);
			 BOOL  wglGetMscRateOML(HDC hdc, INT32 *numerator, INT32 *denominator);
			 INT64  wglSwapBuffersMscOML(HDC hdc, INT64 target_msc, INT64 divisor, INT64 remainder);
			 INT64  wglSwapLayerBuffersMscOML(HDC hdc, int fuPlanes, INT64 target_msc, INT64 divisor, INT64 remainder);
			 BOOL  wglWaitForMscOML(HDC hdc, INT64 target_msc, INT64 divisor, INT64 remainder, INT64 *ust, INT64 *msc, INT64 *sbc);
			 BOOL  wglWaitForSbcOML(HDC hdc, INT64 target_sbc, INT64 *ust, INT64 *msc, INT64 *sbc);
		}

		//WGL_I3D_swap_frame_usage
		version(WGL_I3D_swap_frame_usage)
		{
			 BOOL  wglGetFrameUsageI3D(float *pUsage);
			 BOOL  wglQueryFrameTrackingI3D(DWORD *pFrameCount, DWORD *pMissedFrames, float *pLastMissedUsage);
			 BOOL wglBeginFrameTrackingI3D();
			 BOOL wglEndFrameTrackingI3D();
		}

	}
	else
	{
	} //end linux
}
