// message for READY GO

private import opengl;
private import texture;
private import mymath;
private import std.math;
private import std.random;

class ReadyGo {
static bool first_time;

    this(string filename) {
        this(new Texture(filename));
    }

    this(Texture t0) {
        tex = t0;
        turn = 0;

        for (int j = 0; j < YDIVS2; j++) {
            for (int i = 0; i < XDIVS2; i++) {
                int k = (i+j*XDIVS2)*4;
                int v = i+j*(XDIVS2+1);
                indices[k] = v;
                indices[k+1] = v+1;
                indices[k+2] = v+XDIVS2+2;
                indices[k+3] = v+XDIVS2+1;
            }
        }

        GLfloat[] texc = tex.texcoord;
        for (int j = 0; j <= YDIVS2; j++) {
            for (int i = 0; i <= XDIVS2; i++) {
                int k = (i+j*(XDIVS2+1))*2;
                texcoord[k] = texc[0]*(XDIVS2-i)/XDIVS2+texc[2]*i/XDIVS2;
                texcoord[k+1] = texc[3]*(YDIVS2-j)/YDIVS2+texc[1]*j/YDIVS2;
            }
        }

        void delegate(float t, inout float x, inout float y) gps[];
        gps ~= delegate void(float t, inout float x, inout float y) {
            x = x;
            y = y;
        };
        gps ~= delegate void(float t, inout float x, inout float y) {
            x = x*(cos(t*5))*(1+t*20*y);
            y = y*(sin(t*5)+1)*(1+t*20*x);
        };
        gps ~= delegate void(float t, inout float x, inout float y) {
            x = x+x*y*t*20;
            y = y+y*x*t*20;
        };
        gps ~= delegate void(float t, inout float x, inout float y) {
            x = x+(1-x*y)*(1-x*y)*t;
            y = y+(1-x*y)*(1-x*y)*t;
        };
        gps ~= delegate void(float t, inout float x, inout float y) {
            x = x+x*(1-y)*t*2;
            y = y+(1-y)*t*3;
        };
        gps ~= delegate void(float t, inout float x, inout float y) {
            x = x+rnd(0.5*t);
            y = y+rnd(0.5*t);
        };
        gps ~= delegate void(float t, inout float x, inout float y) {
            x = (1+t*13)*(cos(t*10)*x+sin(t*10)*y);
            y = (1+t*13)*(-sin(t*10)*x+cos(t*10)*y);
        };
        gps ~= delegate void(float t, inout float x, inout float y) {
            x = x * (1 + t * 3);
            y = y + sin(x*t*20) * (1 + t);
        };
        gps ~= delegate void(float t, inout float x, inout float y) {
            x = x * (1 + t*t*30);
            y = y * ((t > 0.2) ? 0.05 : (1 - t * 5));
        };
        gps ~= delegate void(float t, inout float x, inout float y) {
            x = x * (1 + x*x*y*y*t*t*30+t);
            y = y * (1 + x*x*y*y*t*t*30+t);
        };
        gps ~= delegate void(float t, inout float x, inout float y) {
            float xs = (x > 0) ? 1 - x : 1 + x;
            x = x * (1 + xs*xs*t*t*30+t*2);
            y = y * (1 + t*t*20);
        };
        getPos = gps[rnd(gps.length)];
if (!first_time) {
getPos = gps[5];
first_time = true;
}
    }

    void proc() {
        if (turn < 0) {
            turn--;
        }
        else {
            turn++;
        }
    }

    void finish() {
        if (turn >= 0) turn = -1;
    }

    bool done() {
        return turn < -90;
    }

    void draw() {
        float alpha = 0.7;
        if (turn < 0) {
            alpha *= (60.0 + turn) / 60;
        }
        else if (turn < 60) {
            alpha *= turn / 60.0;
        }
        glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
        glColor4f(1, 1, 1, alpha);
        glBegin(GL_QUADS);
        glVertex3f(-1000, -1000, 0);
        glVertex3f(-1000, 1000, 0);
        glVertex3f(1000, 1000, 0);
        glVertex3f(1000, -1000, 0);
        glEnd();

        glBlendFunc(GL_SRC_ALPHA, GL_ONE);

        glEnable(GL_TEXTURE_2D);
        tex.bind();
        GLfloat[] texc = tex.texcoord;

        void normalDraw() {
            glBegin(GL_QUADS);
            glTexCoord3f(texc[0], texc[1], 0);
            glVertex3f(CX-SX, CY-SY, 0);
            glTexCoord3f(texc[0], texc[3], 0);
            glVertex3f(CX-SX, CY+SY, 0);
            glTexCoord3f(texc[2], texc[3], 0);
            glVertex3f(CX+SX, CY+SY, 0);
            glTexCoord3f(texc[2], texc[1], 0);
            glVertex3f(CX+SX, CY-SY, 0);
            glEnd();
        }

        if (turn < 0) {
            transition(-turn);
        }
        else if (turn < 60) {
            transition(60-turn);
        }
        else if (turn >= 60) {
            glColor4f(1, 1, 1, 0.9);
            normalDraw();

            float r = sin((60 - turn) * std.math.PI / 90);
            if (r < 0) return;
            glColor4f(1, 1, 1, r*0.3);

            int eps = 1;

            glPushMatrix();
            glTranslatef(eps, eps, 0);
            normalDraw();
            glPopMatrix();

            glPushMatrix();
            glTranslatef(-eps, eps, 0);
            normalDraw();
            glPopMatrix();

            glPushMatrix();
            glTranslatef(eps, -eps, 0);
            normalDraw();
            glPopMatrix();

            glPushMatrix();
            glTranslatef(-eps, -eps, 0);
            normalDraw();
            glPopMatrix();
        }

/+
        if (turn < 50) {
            glColor4f(1, 1, 1, 0.02*turn);
            normalDraw();
/*
            float tx = (texc[2] - texc[0]) * (10-0.2*turn);
            float ty = (texc[1] - texc[3]) * (10-0.2*turn);
            glBegin(GL_QUADS);
            glTexCoord3f(texc[0]-tx, texc[3]-ty, 0);
            glVertex3f(CX-SX, CY-SY, 0);
            glTexCoord3f(texc[0]-tx, texc[1]+ty, 0);
            glVertex3f(CX-SX, CY+SY, 0);
            glTexCoord3f(texc[2]+tx, texc[1]+ty, 0);
            glVertex3f(CX+SX, CY+SY, 0);
            glTexCoord3f(texc[2]+tx, texc[3]-ty, 0);
            glVertex3f(CX+SX, CY-SY, 0);
            glEnd();
*/
        }
        else if (turn < 80) {
            glColor4f(1, 1, 1, 0.02*(100-turn));
            normalDraw();
        }
        else if (turn < 110) {
            glColor4f(1, 1, 1, 0.9);
            normalDraw();

            glColor4f(1, 1, 1, (turn-80)*0.01);

            int eps = 2;

            glPushMatrix();
            glTranslatef(eps, eps, 0);
            normalDraw();
            glPopMatrix();

            glPushMatrix();
            glTranslatef(-eps, eps, 0);
            normalDraw();
            glPopMatrix();

            glPushMatrix();
            glTranslatef(eps, -eps, 0);
            normalDraw();
            glPopMatrix();

            glPushMatrix();
            glTranslatef(-eps, -eps, 0);
            normalDraw();
            glPopMatrix();
        }
        else if (turn < 200) {
            int t = turn - 110;
            transition(t);
        }
+/
    }

    void transition(int t) {
        float tf = cast(float)t/90;

        glColor4f(1, 1, 1, 1.0-t*0.02);

        int sx = 100;
        int sy = 30 + t*10;

        glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);

        float[(XDIVS*2+1)*2*(YDIVS2*2+1)] coord;
        for (int i = -XDIVS; i <= XDIVS; i++) {
            for (int j = -YDIVS; j <= YDIVS; j++) {
                float x = cast(float)i/XDIVS;
                float y = -cast(float)j/YDIVS;
                getPos(tf, x, y);
                int k = ((i+XDIVS)+(j+YDIVS)*(XDIVS2+1))*2;
                coord[k] = CX + SX * x;
                coord[k+1] = CY + SY * y;
            }
        }

        glEnableClientState(GL_TEXTURE_COORD_ARRAY);
        glEnableClientState(GL_VERTEX_ARRAY);

        glVertexPointer(2, GL_FLOAT, 0, &coord[0]);
        glTexCoordPointer(2, GL_FLOAT, 0, &texcoord[0]);

        glDrawElements(GL_QUADS, indices.length, GL_UNSIGNED_INT, indices.ptr);

        glDisableClientState(GL_TEXTURE_COORD_ARRAY);
        glDisableClientState(GL_VERTEX_ARRAY);

        glEnd();
    }

private:
    static const int XDIVS = 16;
    static const int YDIVS = 16;
    static const int XDIVS2 = XDIVS * 2;
    static const int YDIVS2 = YDIVS * 2;

    static const float CX = 240;
    static const float CY = 240;
    static const float SX = 100;
    static const float SY = 100;

    Texture tex;
    int turn;
    float texcoord[(XDIVS*2+1)*(YDIVS*2+1)*2];
    int indices[XDIVS*2*YDIVS*2*4];

    void delegate(float t, inout float x, inout float y) getPos;

}
