private import SDL;

extern (C):

enum {
	PAD_PUMP_USER       = 0x00000001,
	PAD_PUMP_KEYBOARD   = 0x00000002,
	PAD_PUMP_JOYSTICK   = 0x00000004,
	PAD_PUMP_MOUSE      = 0x00000008,
	PAD_PUMP_EVENT      = 0x00000010,
	PAD_PUMP_EVERYTHING = 0x0000ffff,
}

enum {
	PAD_AXIS_NONE = 0,
	PAD_AXIS_UP = 1,
	PAD_AXIS_DOWN = 2,
	PAD_AXIS_LEFT = 4,
	PAD_AXIS_RIGHT = 8,
	PAD_AXIS_UPLEFT =  PAD_AXIS_UP | PAD_AXIS_LEFT,
	PAD_AXIS_UPRIGHT =  PAD_AXIS_UP | PAD_AXIS_RIGHT,
	PAD_AXIS_DOWNLEFT =  PAD_AXIS_DOWN | PAD_AXIS_LEFT,
	PAD_AXIS_DOWNRIGHT =  PAD_AXIS_DOWN | PAD_AXIS_RIGHT,
}

enum PadKey {
	/* The keyboard syms have been cleverly chosen to map to ASCII */
/*
	PADK_UNKNOWN		= 0,
	PADK_FIRST		= 0,
*/
	PADK_BACKSPACE		= -8,
	PADK_TAB		= -9,
	PADK_CLEAR		= -12,
	PADK_RETURN		= -13,
	PADK_PAUSE		= -19,
	PADK_ESCAPE		= -27,
	PADK_SPACE		= -32,
	PADK_EXCLAIM		= -33,
	PADK_QUOTEDBL		= -34,
	PADK_HASH		= -35,
	PADK_DOLLAR		= -36,
	PADK_AMPERSAND		= -38,
	PADK_QUOTE		= -39,
	PADK_LEFTPAREN		= -40,
	PADK_RIGHTPAREN		= -41,
	PADK_ASTERISK		= -42,
	PADK_PLUS		= -43,
	PADK_COMMA		= -44,
	PADK_MINUS		= -45,
	PADK_PERIOD		= -46,
	PADK_SLASH		= -47,
	PADK_0			= -48,
	PADK_1			= -49,
	PADK_2			= -50,
	PADK_3			= -51,
	PADK_4			= -52,
	PADK_5			= -53,
	PADK_6			= -54,
	PADK_7			= -55,
	PADK_8			= -56,
	PADK_9			= -57,
	PADK_COLON		= -58,
	PADK_SEMICOLON		= -59,
	PADK_LESS		= -60,
	PADK_EQUALS		= -61,
	PADK_GREATER		= -62,
	PADK_QUESTION		= -63,
	PADK_AT			= -64,
	/* 
	   Skip uppercase letters
	 */
	PADK_LEFTBRACKET	= -91,
	PADK_BACKSLASH		= -92,
	PADK_RIGHTBRACKET	= -93,
	PADK_CARET		= -94,
	PADK_UNDERSCORE		= -95,
	PADK_BACKQUOTE		= -96,
	PADK_a			= -97,
	PADK_b			= -98,
	PADK_c			= -99,
	PADK_d			= -100,
	PADK_e			= -101,
	PADK_f			= -102,
	PADK_g			= -103,
	PADK_h			= -104,
	PADK_i			= -105,
	PADK_j			= -106,
	PADK_k			= -107,
	PADK_l			= -108,
	PADK_m			= -109,
	PADK_n			= -110,
	PADK_o			= -111,
	PADK_p			= -112,
	PADK_q			= -113,
	PADK_r			= -114,
	PADK_s			= -115,
	PADK_t			= -116,
	PADK_u			= -117,
	PADK_v			= -118,
	PADK_w			= -119,
	PADK_x			= -120,
	PADK_y			= -121,
	PADK_z			= -122,
	PADK_DELETE		= -127,
	/* End of ASCII mapped keysyms */

	/* International keyboard syms */
	PADK_WORLD_0		= -160,		/* 0xA0 */
	PADK_WORLD_1		= -161,
	PADK_WORLD_2		= -162,
	PADK_WORLD_3		= -163,
	PADK_WORLD_4		= -164,
	PADK_WORLD_5		= -165,
	PADK_WORLD_6		= -166,
	PADK_WORLD_7		= -167,
	PADK_WORLD_8		= -168,
	PADK_WORLD_9		= -169,
	PADK_WORLD_10		= -170,
	PADK_WORLD_11		= -171,
	PADK_WORLD_12		= -172,
	PADK_WORLD_13		= -173,
	PADK_WORLD_14		= -174,
	PADK_WORLD_15		= -175,
	PADK_WORLD_16		= -176,
	PADK_WORLD_17		= -177,
	PADK_WORLD_18		= -178,
	PADK_WORLD_19		= -179,
	PADK_WORLD_20		= -180,
	PADK_WORLD_21		= -181,
	PADK_WORLD_22		= -182,
	PADK_WORLD_23		= -183,
	PADK_WORLD_24		= -184,
	PADK_WORLD_25		= -185,
	PADK_WORLD_26		= -186,
	PADK_WORLD_27		= -187,
	PADK_WORLD_28		= -188,
	PADK_WORLD_29		= -189,
	PADK_WORLD_30		= -190,
	PADK_WORLD_31		= -191,
	PADK_WORLD_32		= -192,
	PADK_WORLD_33		= -193,
	PADK_WORLD_34		= -194,
	PADK_WORLD_35		= -195,
	PADK_WORLD_36		= -196,
	PADK_WORLD_37		= -197,
	PADK_WORLD_38		= -198,
	PADK_WORLD_39		= -199,
	PADK_WORLD_40		= -200,
	PADK_WORLD_41		= -201,
	PADK_WORLD_42		= -202,
	PADK_WORLD_43		= -203,
	PADK_WORLD_44		= -204,
	PADK_WORLD_45		= -205,
	PADK_WORLD_46		= -206,
	PADK_WORLD_47		= -207,
	PADK_WORLD_48		= -208,
	PADK_WORLD_49		= -209,
	PADK_WORLD_50		= -210,
	PADK_WORLD_51		= -211,
	PADK_WORLD_52		= -212,
	PADK_WORLD_53		= -213,
	PADK_WORLD_54		= -214,
	PADK_WORLD_55		= -215,
	PADK_WORLD_56		= -216,
	PADK_WORLD_57		= -217,
	PADK_WORLD_58		= -218,
	PADK_WORLD_59		= -219,
	PADK_WORLD_60		= -220,
	PADK_WORLD_61		= -221,
	PADK_WORLD_62		= -222,
	PADK_WORLD_63		= -223,
	PADK_WORLD_64		= -224,
	PADK_WORLD_65		= -225,
	PADK_WORLD_66		= -226,
	PADK_WORLD_67		= -227,
	PADK_WORLD_68		= -228,
	PADK_WORLD_69		= -229,
	PADK_WORLD_70		= -230,
	PADK_WORLD_71		= -231,
	PADK_WORLD_72		= -232,
	PADK_WORLD_73		= -233,
	PADK_WORLD_74		= -234,
	PADK_WORLD_75		= -235,
	PADK_WORLD_76		= -236,
	PADK_WORLD_77		= -237,
	PADK_WORLD_78		= -238,
	PADK_WORLD_79		= -239,
	PADK_WORLD_80		= -240,
	PADK_WORLD_81		= -241,
	PADK_WORLD_82		= -242,
	PADK_WORLD_83		= -243,
	PADK_WORLD_84		= -244,
	PADK_WORLD_85		= -245,
	PADK_WORLD_86		= -246,
	PADK_WORLD_87		= -247,
	PADK_WORLD_88		= -248,
	PADK_WORLD_89		= -249,
	PADK_WORLD_90		= -250,
	PADK_WORLD_91		= -251,
	PADK_WORLD_92		= -252,
	PADK_WORLD_93		= -253,
	PADK_WORLD_94		= -254,
	PADK_WORLD_95		= -255,		/* 0xFF */

	/* Numeric keypad */
	PADK_KP0		= -256,
	PADK_KP1		= -257,
	PADK_KP2		= -258,
	PADK_KP3		= -259,
	PADK_KP4		= -260,
	PADK_KP5		= -261,
	PADK_KP6		= -262,
	PADK_KP7		= -263,
	PADK_KP8		= -264,
	PADK_KP9		= -265,
	PADK_KP_PERIOD		= -266,
	PADK_KP_DIVIDE		= -267,
	PADK_KP_MULTIPLY	= -268,
	PADK_KP_MINUS		= -269,
	PADK_KP_PLUS		= -270,
	PADK_KP_ENTER		= -271,
	PADK_KP_EQUALS		= -272,

	/* Arrows + Home/End pad */
	PADK_UP			= -273,
	PADK_DOWN		= -274,
	PADK_RIGHT		= -275,
	PADK_LEFT		= -276,
	PADK_INSERT		= -277,
	PADK_HOME		= -278,
	PADK_END		= -279,
	PADK_PAGEUP		= -280,
	PADK_PAGEDOWN		= -281,

	/* Function keys */
	PADK_F1			= -282,
	PADK_F2			= -283,
	PADK_F3			= -284,
	PADK_F4			= -285,
	PADK_F5			= -286,
	PADK_F6			= -287,
	PADK_F7			= -288,
	PADK_F8			= -289,
	PADK_F9			= -290,
	PADK_F10		= -291,
	PADK_F11		= -292,
	PADK_F12		= -293,
	PADK_F13		= -294,
	PADK_F14		= -295,
	PADK_F15		= -296,

	/* Key state modifier keys */
	PADK_NUMLOCK		= -300,
	PADK_CAPSLOCK		= -301,
	PADK_SCROLLOCK		= -302,
	PADK_RSHIFT		= -303,
	PADK_LSHIFT		= -304,
	PADK_RCTRL		= -305,
	PADK_LCTRL		= -306,
	PADK_RALT		= -307,
	PADK_LALT		= -308,
	PADK_RMETA		= -309,
	PADK_LMETA		= -310,
	PADK_LSUPER		= -311,		/* Left "Windows" key */
	PADK_RSUPER		= -312,		/* Right "Windows" key */
	PADK_MODE		= -313,		/* "Alt Gr" key */
	PADK_COMPOSE		= -314,		/* Multi-key compose key */

	/* Miscellaneous function keys */
	PADK_HELP		= -315,
	PADK_PRINT		= -316,
	PADK_SYSREQ		= -317,
	PADK_BREAK		= -318,
	PADK_MENU		= -319,
	PADK_POWER		= -320,		/* Power Macintosh power key */
	PADK_EURO		= -321,		/* Some european keyboards */
	PADK_UNDO		= -322,		/* Atari keyboard has Undo */

	/* Add any other keys here */

	/* descending order... */

	PADJ1_AXIS		= -340,
	PADJ1_UP		= PADJ1_AXIS + PAD_AXIS_UP,
	PADJ1_DOWN		= PADJ1_AXIS + PAD_AXIS_DOWN,
	PADJ1_LEFT		= PADJ1_AXIS + PAD_AXIS_LEFT,
	PADJ1_RIGHT	= PADJ1_AXIS + PAD_AXIS_RIGHT,

	PADJ1_BUTTON	= -360,
	PADJ1_BUTTON0	= PADJ1_BUTTON + 0,
	PADJ1_BUTTON1	= PADJ1_BUTTON + 1,
	PADJ1_BUTTON2	= PADJ1_BUTTON + 2,
	PADJ1_BUTTON3	= PADJ1_BUTTON + 3,
	PADJ1_BUTTON4	= PADJ1_BUTTON + 4,
	PADJ1_BUTTON5	= PADJ1_BUTTON + 5,
	PADJ1_BUTTON6	= PADJ1_BUTTON + 6,
	PADJ1_BUTTON7	= PADJ1_BUTTON + 7,
	PADJ1_BUTTON8	= PADJ1_BUTTON + 8,
	PADJ1_BUTTON9	= PADJ1_BUTTON + 9,
	PADJ1_BUTTON10	= PADJ1_BUTTON + 10,
	PADJ1_BUTTON11	= PADJ1_BUTTON + 11,
	PADJ1_BUTTON12	= PADJ1_BUTTON + 12,
	PADJ1_BUTTON13	= PADJ1_BUTTON + 13,
	PADJ1_BUTTON14	= PADJ1_BUTTON + 14,
	PADJ1_BUTTON15	= PADJ1_BUTTON + 15,
	PADJ1_BUTTON16	= PADJ1_BUTTON + 16,
	PADJ1_BUTTON17	= PADJ1_BUTTON + 17,
	PADJ1_BUTTON18	= PADJ1_BUTTON + 18,
	PADJ1_BUTTON19	= PADJ1_BUTTON + 19,

	PADJ2_AXIS		= -370,
	PADJ2_UP		= PADJ2_AXIS + PAD_AXIS_UP,
	PADJ2_DOWN		= PADJ2_AXIS + PAD_AXIS_DOWN,
	PADJ2_LEFT		= PADJ2_AXIS + PAD_AXIS_LEFT,
	PADJ2_RIGHT	= PADJ2_AXIS + PAD_AXIS_RIGHT,

	PADJ2_BUTTON	= -390,
	PADJ2_BUTTON0	= PADJ2_BUTTON + 0,
	PADJ2_BUTTON1	= PADJ2_BUTTON + 1,
	PADJ2_BUTTON2	= PADJ2_BUTTON + 2,
	PADJ2_BUTTON3	= PADJ2_BUTTON + 3,
	PADJ2_BUTTON4	= PADJ2_BUTTON + 4,
	PADJ2_BUTTON5	= PADJ2_BUTTON + 5,
	PADJ2_BUTTON6	= PADJ2_BUTTON + 6,
	PADJ2_BUTTON7	= PADJ2_BUTTON + 7,
	PADJ2_BUTTON8	= PADJ2_BUTTON + 8,
	PADJ2_BUTTON9	= PADJ2_BUTTON + 9,
	PADJ2_BUTTON10	= PADJ2_BUTTON + 10,
	PADJ2_BUTTON11	= PADJ2_BUTTON + 11,
	PADJ2_BUTTON12	= PADJ2_BUTTON + 12,
	PADJ2_BUTTON13	= PADJ2_BUTTON + 13,
	PADJ2_BUTTON14	= PADJ2_BUTTON + 14,
	PADJ2_BUTTON15	= PADJ2_BUTTON + 15,
	PADJ2_BUTTON16	= PADJ2_BUTTON + 16,
	PADJ2_BUTTON17	= PADJ2_BUTTON + 17,
	PADJ2_BUTTON18	= PADJ2_BUTTON + 18,
	PADJ2_BUTTON19	= PADJ2_BUTTON + 19,

	PADM_BUTTON           = -390,
	PADM_BUTTONLEFT       = -391,
	PADM_BUTTONMIDDLE     = -392,
	PADM_BUTTONRIGHT      = -393,
	PADM_BUTTONWHEELUP    = -394,
	PADM_BUTTONWHEELDOWN  = -395,

	PADE_QUIT		= -396,

	PAD_UNUSED      = -399,

	PAD_LAST        = -400

}

enum {
	PADKEY_NUM = 400
}

enum {
	PAD_A_BUTTON, PAD_B_BUTTON, PAD_C_BUTTON, PAD_D_BUTTON, PAD_E_BUTTON,
	PAD_UP_BUTTON, PAD_RIGHT_BUTTON, PAD_DOWN_BUTTON, PAD_LEFT_BUTTON,
	PAD_END_BUTTON
}

int Pad_Init();

void Pad_Pump(Uint32 flags);

int Pad_GetButton(int id);

int Pad_GetButtonPushed(int id);
int Pad_GetButtonPressed(int id);
int Pad_GetButtonPulled(int id);
int Pad_GetButtonReleased(int id);

int Pad_AddButton(int id, int addid);

int Pad_GetAxis(int id);

void Pad_AddAxis(int id, int upid, int rightid, int downid, int leftid);

void Pad_AddAxisKeyboardArrow(int id);
void Pad_AddAxisKeyboardRogue(int id);
void Pad_AddAxisKeyboardWASD(int id);
void Pad_AddAxisJoystick1(int id);
void Pad_AddAxisJoystick2(int id);

//int Pad_LoadDefault(invariant char* file);
int Pad_LoadDefault(const char* file);
int Pad_Load(const char* file, char** bnames, char** anames);

int Pad_LoadRW(SDL_RWops* op, char** bnames, char** anames);

int Pad_SaveDefault(char* file);
int Pad_Save(char* file, char** bnames, char** anames);

int Pad_SaveRW(SDL_RWops* op, char** bnames, char** anames);

Sint16 Pad_JoystickGetAxis(SDL_Joystick* joystick, int axis, Uint32 mode);
Uint8 Pad_JoystickGetButton(SDL_Joystick* joystick, int button);

void Pad_SetJoystickThresholdUp(int val);
void Pad_SetJoystickThresholdRight(int val);
void Pad_SetJoystickThresholdDown(int val);
void Pad_SetJoystickThresholdLeft(int val);

PadKey Pad_PadKeyFromEvent(SDL_Event* ev);

char* Pad_GetError() {
    return SDL_GetError();
}
